; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_credits:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ;Charge l'alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Charge le logo miniature
  ld     hl,(:tiles_minilogo*$4000)+tiles_minilogo
  ld     de,$8000+(96*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;map le logo sur la window
  ld     bc,$0604
  ld     a,96
  ld     hl,$9C00+7
  call   mapinc

  xor    a
  ldh    ($42),a                ;Scroll Y
  ld     (BKG_Y),a
  ldh    ($43),a                ;Scroll X

  ld     a,108
  ldh    ($4A),a                ;Window Y
  ld     a,7
  ldh    ($4B),a                ;Window X

  ld     a,%11100100
  ldh    ($47),a                ;BG palette
  ldh    ($48),a                ;SPR0 palette

  ld     a,%11110001            ;Turn screen on, BG on, sprites OFF, window ON, tiles at $8000, window map at $9C00
  ldh    ($40),a

  ld     a,%00011000            ;Vblank+RLI
  ldh    ($41),a
  ld     a,%00000011
  ldh    ($FF),a

  ld     de,$9800+(32*12)+2
  ld     hl,Scroll_MapPtr
  rst    $10
  
  ld     de,text_credits
  ld     hl,Scroll_TxtPtr
  rst    $10
  
  ld     de,Setup_title
  ld     hl,Scroll_JumpTo
  rst    $10

  ld     hl,VBL_HANDLER
  ld     de,VBL_credits
  ld     (hl),e
  inc    hl
  ld     (hl),d
  
  ld     de,RLI_credits
  call   load_RLI

  xor    a
  ld     (VBLC),a
  
  ld     a,16*6+12
  ld     (Scroll_Fade_End),a

  ei
  ret


VBL_credits:
  xor    a
  ldh    ($47),a                ;BG palette

  ld     a,(FRAME)              ;Update scroll every 4 frames
  and    3
  jr     nz,+++

  call   update_scroller

+++:
  call   readinput              ;Return to title screen if button press
  and    $0F
  jr     z,+
  call   Setup_title
+:
  ret
  
RLI_credits:
  push   de
  push   hl
  ldh    a,($44)
  ld     hl,Scroll_Fade_End
  cp     (hl)
  jr     nc,+
  swap   a                      ;LY < Scroll_Fade_End: LY/16 = LUT palette
  and    $F
  ld     hl,tbl_fadein
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti
+:                              ;LY > Scroll_Fade_End: normal palette
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti

text_clear:
.db "                ",$FF

text_credits:
.db "Code/Graphismes:",$FF
.db $FF
.db "         Furrtek",$FF
.db $FF,$FF
.db "Musique/FX:",$FF
.db $FF
.db "       Don Ratta",$FF
.db $FF,$FF
.db "Remerciements:",$FF
.db $FF
.db "            Dyak",$FF
.db "         ElBarto",$FF
.db " Marat Fayzullin",$FF
.db "    Martin Korth",$FF
.db "       Nitro2k01",$FF
.db "           Orion",$FF
.db "       RayXambeR",$FF
.db "        Realmyop",$FF
.db "         Robotwo",$FF
.db "         Scruffy",$FF
.db "     Ville Helin",$FF
.db $FF,$FF,$FF,$FF
.db "Les connards du",$FF
.db "monde entier.",$FF
.db $FF,$FF,$FF,$FF
.db "Et vous, bien",$FF
.db "entendu !",$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00

tbl_fadein:
.db %00000000,%01010100,%10100100,%11100100,%10100100,%01010100,%00000000
