; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

.DEFINE MAX_WAGONS 12 		; 3 trains made of 4 wagons max
.DEFINE DELAY_WAGONS 12		; Frames to wait between each wagon launch
.DEFINE WAGONSPERTRAIN 4

gc_update_sprites:
;----------------------------------------------------------------
;Launch wagons if needed
  ld     a,(TOLAUNCH)
  or     a
  jr     z,+
  ld     a,(TIMER_LAUNCH)
  dec    a
  ld     (TIMER_LAUNCH),a
  jr     nz,++
  call   wagon_launch
  ld     a,(TOLAUNCH)
  or     a
  jr     nz,++
  ;Prepare type of next train
  call   get_random
  swap   a
  and    3
  ld     (NEXT_TYPE),a
  ;Display
  call   disp_nexttrain
  jr     ++
+:
  ld     a,(TIMER_TRAIN)
  dec    a
  ld     (TIMER_TRAIN),a
  jr     nz,++
  call   train_launch
++:

;Update wagons
  ld     hl,WAGONLIST
  ld     b,MAX_WAGONS
-:
  ld     a,(hl)			;Type/Step
  and    $F			;Step
  or     a
  jr     z,+
  push   hl
  push   bc
  call   wagon_moving
  pop    bc
  pop    hl
+:
  inc    hl
  inc    hl
  inc    hl
  inc    hl
  inc    hl
  dec    b
  jr     nz,-
  ret
  
  
disp_nexttrain:
  ld     de,$9800+(32*16)+12
  sla    a
  add    GC_T_SYM0
  call   wait_write
  ld     (de),a
  ret


wagon_moving:
  ;Update positions according to goal
XMOD:
  inc    hl
  ldi    a,(hl)			;Goal X
  inc    hl
  ld     c,a
  ld     a,(hl)		        ;X
  cp     c
  jr     z,++
  jr     c,+
  dec    a
  ld     (hl),a			;X
  jr     ++
+:
  inc    a
  ld     (hl),a			;X
++:
  dec    hl

YMOD:
  ldi    a,(hl)			;Goal Y
  inc    hl
  ld     c,a
  ld     a,(hl)			;Y
  cp     c
  jr     z,++
  jr     c,+
  dec    a
  ld     (hl),a			;Y
  jr     ++
+:
  inc    a
  ld     (hl),a			;Y
++:

  ld     c,(hl)			;Y
  dec    hl
  dec    hl
  ld     a,(hl)			;Goal Y
  cp     c
  ret    nz

  dec    hl
  ld     c,(hl)		        ;Goal X
  inc    hl
  inc    hl
  ld     a,(hl)			;X
  cp     c
  ret    nz

  ;Position = goal
  ;Jump table to update the goal and the step according to rails
  dec    hl
  dec    hl
  dec    hl
  ld     a,(hl)			;Type/Step (Step)
  inc    a
  ld     (hl),a                 ;Type/Step (Step)
  and    $F
  dec    a
  dec    a
  push   hl
  ld     hl,jt_locoanim
  ld     d,0
  sla    a
  ld     e,a
  add    hl,de
  ldi    a,(hl)
  ld     d,(hl)
  ld     e,a
  pop    hl
  push   de			;RET in DE
  ret


jt_locoanim:
.dw loco_step1,loco_step2,loco_step3


loco_step1:
  ; Go to step 2, switch 1
  ld     a,(TRACKSTATE)
  bit    1,a
  ld     a,56
  jr     z,+
  ld     a,104
+:
  inc    hl
  ldi    (hl),a			;Goal X
  ld     a,94
  ld     (hl),a		        ;Goal Y
  ret

loco_step2:
  ; Go to step 3, switch 2
  inc    hl
  inc    hl
  inc    hl
  ldd    a,(hl)			;X
  cp     56
  jr     z,++
  ; Droite
  ld     a,(TRACKSTATE)
  bit    2,a
  ld     a,104
  jr     z,+
  ld     a,136
+:
  dec    hl
  ldi    (hl),a			;Goal X
  ld     a,38
  ld     (hl),a			;Goal Y
  ret

++:
  ; Gauche
  ld     a,(TRACKSTATE)
  bit    0,a
  ld     a,56
  jr     z,+
  ld     a,24
+:
  dec    hl
  ldi    (hl),a			;Goal X
  ld     a,38
  ld     (hl),a			;Goal Y
  ret

loco_step3:
  ;Scoring
  ;Decision from the X position: 24,56,104,136
  ld     a,(hl)			;Type/Step: C = Train type
  swap   a
  and    3
  ld     c,a

  push   hl
  ld     b,0
  ld     hl,CAMP1_TYPE
-:
  ld     a,(hl)
  cp     c
  jr     z,+
  inc    hl
  inc    b
  jr     -
+:
  ld     a,b
  ld     hl,x_camp
  rst    $0			;C = good X for that type
  ld     c,a
  pop    hl
  inc    hl
  inc    hl
  inc    hl
  ld     a,(hl)			;X
  cp     c
  jr     z,scoreplus
  ; Mauvais camp
  ld     a,(INVINC)
  or     a
  jr     nz,+		;No need to check for collision if invincible
  push   hl
  ld     hl,fx_grabpoison
  call   playsfx
  ld     hl,LIVES
  dec    (hl)    	;The gameover is done in gk_update_lives
  ld     a,GC_T_LIFE	;Lives tiles
  ld     c,GC_T_BLANK
  call   update_lives
  ;16bit BCD dec -200
  ld     hl,SCORE       ;HL=(SCORE)
  ldi    a,(hl)
  ld     l,(hl)
  cp     2
  jr     nc,++
  ld     hl,0		;Limit to 0 if <200
  jr     +++
++:
  sub    2		;-200
  daa
  ld     h,a
+++:
  ld     a,h            ;(SCORE)=HL
  ld     (SCORE),a
  ld     a,l
  ld     (SCORE+1),a
  ld     c,GC_T_BIGNUMS
  call   disp_score     ;Update score display
  call   gen_passwd	;Regenerate password for pause mode with present score
  ld     hl,$9800+10    ;Display password
  ld     de,PASSWD_GEN
  ld     b,$82
  call   maptext
  ld     a,$FF
  ld     (INVINC),a
  pop    hl
+:
  dec    hl
  dec    hl
  dec    hl
  call   wagon_init
  ret

scoreplus:
  ; Good camp
  dec    hl
  dec    hl
  dec    hl
  push   hl
  ld     a,(hl)
  swap   a
  and    3
  ld     d,0
  ld     e,a
  ld     hl,camp_scoretable
  add    hl,de
  ld     a,(TOADD)
  add    (hl)           ; Player inc scores !
  ld     (TOADD),a
  pop    hl
  call   wagon_init
  ret




gc_render_sprites:
;----------------------------------------------------------------
  ld     hl,OAMCOPY

  ; Cursor
  ld     a,(INVINC)
  bit    4,a
  jr     nz,+
  push   hl
  ld     hl,camp_curpos
  ld     a,(TRACK_CUR)
  sla    a
  rst    0
  ld     d,a
  inc    hl
  ld     e,(hl)
  pop    hl

  ld     a,e
  ld     (SPR16_Y),a
  ld     a,d
  ld     (SPR16_X),a
  ld     a,GC_T_ARROW
  ld     (SPR16_N),a
  xor    a
  ld     (SPR16_A),a
  call   make8x16sprite
+:

  ; Wagons/loco
  ld     de,WAGONLIST
  ld     b,MAX_WAGONS
  ld     c,0
-:
  ld     a,(de)			;Type/Step
  and    $F			;Step
  or     a
  jr     z,+
  inc    c			;C is used for "no trains on the screen" detection
  push   bc
  push   de
  call   render_wagon
  pop    de
  pop    bc
+:
  inc    de
  inc    de
  inc    de
  inc    de
  inc    de
  dec    b
  jr     nz,-

  ;Conditions to stop the train sound:
  ld     a,c
  or     a
  jr     nz,+
  ld     a,(TOLAUNCH)		;No trains on screen
  or     a
  jr     nz,+
  ld     a,(PAUSESND)
  or     a
  ret    nz
  jp     stopmusic
+
  ld     a,(PAUSESND)
  or     a
  ret    z
  ld     a,(Sot_Flags)		;Wait for the sound to be read
  and    Sot_F_Play
  ret    nz
  ld     a,(PAUSE_FLAG)
  bit    2,a
  jr     z,trainsound
  ret


render_wagon:
  push   de
  ld     a,(de)			;Type/Step
  bit    7,a
  ld     c,GC_T_WAGON_S
  jr     z,+
  ld     c,GC_T_LOCO_S
+:

  inc    de
  ld     a,(de)			;Goal X, decision of the orientation of the wagon/loco sprite
  inc    de
  inc    de
  ld     b,a
  ld     a,(de)		        ;X
  cp     b
  jr     z,++
  jr     c,+
  inc    c			;Left (+4)
  inc    c
  inc    c
  inc    c
  jr     ++
+:
  ld     a,c                    ;Right (+8)
  add    8
  ld     c,a
++:
  ld     a,c
  ld     (SPR16_N),a

  ld     a,(de)			;X
  inc    de
  ld     (SPR16_X),a
  ld     a,(de)                 ;Y
  ld     (SPR16_Y),a
  xor    a
  ld     (SPR16_A),a
  call   make8x16sprite
  
  ;Symbol next to wagon/loco
  pop    de
  ld     a,(de)			;Type/Step
  swap   a
  and    3
  sla    a
  add    GC_T_SYM0
  ld     b,a
  inc    de			;GoalX
  inc    de                     ;GoalY
  inc    de			;X
  inc    de			;Y
  ld     a,(de)
  add    4
  ldi    (hl),a			;Y OAM
  dec    de			;X
  ld     a,(de)
  add    20			;Offset on the right of the wagon
  ldi    (hl),a			;X OAM
  ld     a,b
  ldi    (hl),a			;N OAM
  xor    a
  ldi    (hl),a			;A OAM
  ret
  
  
  
train_launch:
  ld     a,WAGONSPERTRAIN
  ld     (TOLAUNCH),a
  ld     a,1
  ld     (TIMER_LAUNCH),a
  ld     a,(SCORE)      	;Make train speed from score
  dec    a			;Neg
  cpl
  add    $F0			;A=($F0-A): Delay between trains: ScoreH=0: $F0, ScoreH=$99: $F0-$99
  ld     (TIMER_TRAIN),a
  call   trainsound
  ret
  
  
trainsound:
  ld     de,music_fx_train
  ld     hl,Sot_Music
  rst    $10
  call   setupmusic
  ld     a,Sot_F_Play+Sot_F_Loop
  ld     (Sot_Flags),a
  xor    a
  ld     (PAUSESND),a
  ret


wagon_launch:
  ;Looks if a wagon slot is available
  ld     a,(TOLAUNCH)
  cp     WAGONSPERTRAIN
  ld     c,0			;Wagon by defaut
  jr     nz,+
  ld     c,%10000000		;Loco flag
+:
  ld     a,(NEXT_TYPE)
  swap   a
  or     c
  ld     c,a

  ld     hl,WAGONLIST
  ld     b,MAX_WAGONS
-:
  ld     a,(hl)
  or     a
  jr     z,++
  ld     de,5
  add    hl,de
  dec    b
  jr     nz,-
  ret				;No free wagon, do nothing :(
++:
  ;Found !
  inc    a
  or     c
  ldi    (hl),a			;Planned type, loco or wagon, Step 1
  ;Goals init to go to the first rail switch
  ld     a,80
  ldi    (hl),a			; Goal X
  ld     a,134
  ld     (hl),a                 ; Goal Y
  ld     a,DELAY_WAGONS
  ld     (TIMER_LAUNCH),a
  ld     hl,TOLAUNCH
  dec    (hl)
  ret


gc_inc_score:
;----------------------------------------------------------------
;Progressive inc of score
  ld     a,(TOADD)
  or     a
  jr     z, +                   ;Nothing to add

  call   sh_incscore

  ld     c,87
  call   disp_score             ;Update score display
+:
  ret
  
  
  
track_update:
  ld     a,(TRACK_CUR)
  ld     hl,jt_trackupd
  ld     d,0
  sla    a
  ld     e,a
  add    hl,de
  ldi    a,(hl)			;DE=(jt_world+2*WORLDSEL)
  ld     d,(hl)
  ld     e,a
  push   de
  ret


jt_trackupd:
.dw trackupd_left
.dw trackupd_middle
.dw trackupd_right


trackupd_left:
  ld     a,(TRACKSTATE)
  bit    0,a
  jr     nz,+
  ;Straight
  ld     a,GC_T_LAYOUT
  ld     de,$9804+(32*9)
  ld     hl,(:track_l_s*$4000)+track_l_s
  call   map
  jr     ++
+:
  ;Across
  ld     a,GC_T_LAYOUT
  ld     de,$9804+(32*9)
  ld     hl,(:track_l_c*$4000)+track_l_c
  call   map
++:
  ret
  
  
trackupd_middle:
  ld     a,(TRACKSTATE)
  bit    1,a
  jr     nz,+
  ;Left
  ld     a,GC_T_LAYOUT
  ld     de,$9808+(32*15)
  ld     hl,(:track_m_l*$4000)+track_m_l
  call   map
  jr     ++
+:
  ;Across
  ld     a,GC_T_LAYOUT
  ld     de,$9808+(32*15)
  ld     hl,(:track_m_r*$4000)+track_m_r
  call   map
++:
  ret


trackupd_right:
  ld     a,(TRACKSTATE)
  bit    2,a
  jr     nz,+
  ;Straight
  ld     a,GC_T_LAYOUT
  ld     de,$980C+(32*9)
  ld     hl,(:track_r_s*$4000)+track_r_s
  call   map
  jr     ++
+:
  ;Across
  ld     a,GC_T_LAYOUT
  ld     de,$980C+(32*9)
  ld     hl,(:track_r_c*$4000)+track_r_c
  call   map
++:
  ret
  
  
wagon_init:
  xor    a
  ld     (hl),a			;Type/Step (enter HL with Type/Step)
  ld     a,80
  ld     c,160
  inc    hl
  ld     (hl),a			;Goal X
  inc    hl
  ld     (hl),c			;Goal Y
  inc    hl
  ld     (hl),a			;X
  inc    hl
  ld     (hl),c			;Y
  ret

camp_curpos:		; X/Y
.db 72,88
.db 108,134
.db 130,88

x_camp:
.db 24,56,104,136

camp_scoretable:
.db 5,10,15,20
