; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

gc_input:
;----------------------------------------------------------------
;User input handling
  ld     hl,PAUSE_FLAG		;Only allow to get out of pause or quit if in pause mode
  bit    0,(hl)
  jp     nz,+++

  ld     a,(JOYP_ACTIVE)
  bit    0,a
  jr     z,+                    ;A button: modify rail switch state
  ld     c,1
  ld     a,(TRACK_CUR)
  or     a
  jr     z,++		;0:1
  sla    c
  dec    a
  jr     z,++           ;1:2
  sla    c              ;2:4
++:
  ld     a,(TRACKSTATE)
  xor    c
  ld     (TRACKSTATE),a
  call   track_update
  ld     hl,fx_track
  call   playsfx
+:


  ld     a,(JOYP_ACTIVE)
  bit    1,a
  jr     z,+                    ;B button: force train launch
  ld     a,(TOLAUNCH)		;Do not allow launch if already launching
  or     a
  jr     nz,+
  call   train_launch
+:


  ld     a,(JOYP_ACTIVE)
  bit    4,a                    ;Right
  jr     z,+
  ld     a,2
  ld     (TRACK_CUR),a
  ld     hl,fxscore
  call   playsfx
+:

  ld     a,(JOYP_ACTIVE)
  bit    5,a                    ;Left
  jr     z,+
  xor    a
  ld     (TRACK_CUR),a
  ld     hl,fxscore
  call   playsfx
+:

  ld     a,(JOYP_ACTIVE)
  bit    6,a                    ;Up
  jr     z,+
  ld     a,(TRACK_CUR)
  cp     1
  jr     nz,+
  xor    a
  ld     (TRACK_CUR),a
  ld     hl,fxscore
  call   playsfx
+:

  ld     a,(JOYP_ACTIVE)
  bit    7,a                    ;Down
  jr     z,+
  ld     a,1
  ld     (TRACK_CUR),a
  ld     hl,fxscore
  call   playsfx
+:


+++:
  call   pause_b_handler

  ld     a,(JOYP_ACTIVE)
  bit    3,a
  jr     z,+                    ;Start button
  ;Pause !
  ld     a,(PAUSE_FLAG)
  bit    2,a
  jr     nz,+			;Can't do nothing if pause forced from gameover
  xor    1
  ld     (PAUSE_FLAG),a
  or     a
  jr     z,++
  ;Enter pause mode
  ld     b,$A0-30		;Alphabet
  call   enter_pause
  jr     +
++:
  ;Exit pause mode
  ld     b,GC_T_BLANK		;Blank tile
  call   exit_pause
  ld     a,$FF
  ld     (PAUSESND),a
+:
  ret

