; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

  .INCLUDE "gamecamp_aux.asm"
  .INCLUDE "gamecamp_vbl.asm"
  .INCLUDE "gamecamp_input.asm"
  .INCLUDE "gamecamp_tmaps.asm"

  .DEFINE GC_T_BLANK     0
  .DEFINE GC_T_LAYOUT    0
  .DEFINE GC_T_ARROW     $2C
  .DEFINE GC_T_LOCO_S    $30
  .DEFINE GC_T_LOCO_CL   $34
  .DEFINE GC_T_LOCO_CR   $38
  .DEFINE GC_T_WAGON_S   $3C
  .DEFINE GC_T_WAGON_CL  $40
  .DEFINE GC_T_WAGON_CR  $44
  .DEFINE GC_T_SYM0      $48
  .DEFINE GC_T_SYM1      $4A
  .DEFINE GC_T_SYM2      $4C
  .DEFINE GC_T_SYM3      $4E
  .DEFINE GC_T_BIGNUMS   87
  .DEFINE GC_T_LIFE	 147
  .DEFINE GC_T_ALPHA     158

Setup_gamecamp:
  di
  call	 screen_off
  
  ld     hl,$8000
  ld     bc,(GC_T_SYM3+2)*16
  call   clear

  ld     hl,(:tiles_trainlyt*$4000)+tiles_trainlyt
  ld     de,$8000+(GC_T_LAYOUT*16)
  call   loadtiles_auto

  ld     hl,(:tiles_fleche*$4000)+tiles_fleche
  ld     de,$8000+(GC_T_ARROW*16)
  call   loadtiles_auto
  
  ld     hl,(:tiles_loco_s*$4000)+tiles_loco_s
  ld     de,$8000+(GC_T_LOCO_S*16)
  call   loadtiles_auto
  ld     hl,(:tiles_loco_cl*$4000)+tiles_loco_cl
  ld     de,$8000+(GC_T_LOCO_CL*16)
  call   loadtiles_auto
  ld     hl,(:tiles_loco_cr*$4000)+tiles_loco_cr
  ld     de,$8000+(GC_T_LOCO_CR*16)
  call   loadtiles_auto
  
  ld     hl,(:tiles_wagon_s*$4000)+tiles_wagon_s
  ld     de,$8000+(GC_T_WAGON_S*16)
  call   loadtiles_auto
  ld     hl,(:tiles_wagon_cl*$4000)+tiles_wagon_cl
  ld     de,$8000+(GC_T_WAGON_CL*16)
  call   loadtiles_auto
  ld     hl,(:tiles_wagon_cr*$4000)+tiles_wagon_cr
  ld     de,$8000+(GC_T_WAGON_CR*16)
  call   loadtiles_auto
  
  ld     hl,(:tiles_gc_sym0*$4000)+tiles_gc_sym0
  ld     de,$8000+(GC_T_SYM0*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym1*$4000)+tiles_gc_sym1
  ld     de,$8000+(GC_T_SYM1*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym2*$4000)+tiles_gc_sym2
  ld     de,$8000+(GC_T_SYM2*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym3*$4000)+tiles_gc_sym3
  ld     de,$8000+(GC_T_SYM3*16)
  call   loadtiles_auto

  ld     de,$8000+(GC_T_BIGNUMS*16)
  call   load_bignumbers

  ld     hl,(:tile_starmini*$4000)+tile_starmini
  ld     de,$8000+(GC_T_LIFE*16)
  call   loadtiles_auto
  
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000+(GC_T_ALPHA*16)
  call   loadtiles_auto

  ld     de,$8000+($DA*16)
  ld     hl,(:tiles_continuer*$4000)+tiles_continuer
  call   loadtiles_auto
  ld     de,$8000+($EE*16)
  ld     hl,(:tiles_quitter*$4000)+tiles_quitter
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ld     a,GC_T_LAYOUT
  ld     de,$9800+(32*3)
  ld     hl,(:map_trainlyt*$4000)+map_trainlyt
  call   map

  ;Clear top of the screen (score and lives)
  ld     a,GC_T_BLANK
  ld     hl,$9800
  ld     b,32*3
-:
  ldi    (hl),a
  dec    b
  jr     nz,-

  xor    a
  ld     (BKG_X),a
  ld     (TOADD),a
  ld     (PAUSE_FLAG),a
  ld     (TRACK_CUR),a
  ld     (FADEIDX),a
  ld     (PAUSESND),a
  ld     (TIMER_TRAIN),a
  ld     (TOLAUNCH),a
  dec    a
  ld     (INVINC),a
  call   get_random
  and    7
  ld     (TRACKSTATE),a
  and    3
  ld     (NEXT_TYPE),a
  ld     a,$DA
  ld     (SPR_PAUSEBAN),a
  ld     hl,RESETX
  set    0,(hl)

  ld     a,0
  ld     (TRACK_CUR),a
  call   track_update
  ld     a,1
  ld     (TRACK_CUR),a
  call   track_update
  ld     a,2
  ld     (TRACK_CUR),a
  call   track_update

  ld     b,2
  call   setgame

  ld     a,(GAME_FLAGS)
  bit    7,a
  call   nz,ivars

  ld     c,GC_T_BIGNUMS
  call   disp_score             ;Update score display

  ld     a,GC_T_LIFE		;Lives tiles
  ld     c,GC_T_BLANK
  call   update_lives
  
  call   get_random 		;Init camp types (randomized)
  ld     hl,CAMP1_TYPE
  ld     b,4
-:
  inc    a
  and    3
  ldi    (hl),a
  dec    b
  jr     nz,-

  ld     hl,CAMP1_TYPE
  ld     de,$9800+(32*5)+1
  ldi    a,(hl)
  sla    a
  add    GC_T_SYM0
  ld     (de),a
  ld     de,$9800+(32*5)+5
  ldi    a,(hl)
  sla    a
  add    GC_T_SYM0
  ld     (de),a
  ld     de,$9800+(32*5)+11
  ldi    a,(hl)
  sla    a
  add    GC_T_SYM0
  ld     (de),a
  ld     de,$9800+(32*5)+15
  ldi    a,(hl)
  sla    a
  add    GC_T_SYM0
  ld     (de),a

  ld     a,(NEXT_TYPE)
  call   disp_nexttrain

  ld     hl,WAGONLIST		;Init all wagons
  ld     b,MAX_WAGONS
-:
  call   wagon_init
  inc    hl
  dec    b
  jr     nz,-

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11100100            ;BG palette
  ldh    ($47),a
  ld     a,%11100100            ;SPR0 palette
  ldh    ($48),a
  ld     a,%11010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a
  ld     a,%01000000            ;Vblank only
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  call   startsfx

  ld     hl,VBL_HANDLER
  ld     de,VBL_gamecamp
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_null
  call   load_RLI

  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei

  ret
