; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

gk_input:
;----------------------------------------------------------------
;User input handling
  ld     hl,PAUSE_FLAG		;Only allow to get out of pause or quit if in pause mode
  bit    0,(hl)
  jr     nz,+++

  ld     a,(JOYP_ACTIVE)
  bit    0,a
  jr     z,+                    ;A button
  ld     a,(CLENCH)
  or     a
  jr     nz,+                   ;Prevents keeping the hand closed all the time (CLENCH has to hit 0)
  call   checkgrab
  call   fistiniere
  ld     a,$20                  ;Timeout hand reopening
  ld     (CLENCH),a
+:

  ld     a,(JOYP_CURRENT)
  bit    4,a                    ;Right
  jr     z,+
  ld     hl,HAND_I
  dec    (hl)                   ;Dec inertia
  dec    (hl)
+:

  ld     a,(JOYP_CURRENT)
  bit    5,a                    ;Left
  jr     z,+
  ld     hl,HAND_I
  inc    (hl)                   ;Inc inertia
  inc    (hl)
+:

  ld     a,(HAND_I)             ;HAND_X += (HAND_I>>2)
  sra    a
  sra    a
  ld     b,a
  ld     a,(HAND_X)
  add    b
  cp     $88                    ;Right limit
  jr     nc,+
  ld     a,(HAND_I)
  sra    a
  cpl                           ;Bounce: invert and half inertia
  ld     (HAND_I),a
  ld     a,$88
  jr     ++
+:
  cp     $F8                    ;Left limit
  jr     c,++
  ld     a,(HAND_I)
  sra    a
  cpl                           ;Bounce: invert and half inertia
  ld     (HAND_I),a
  ld     a,$F8
++:
  ld     (HAND_X),a

+++:
  call   pause_b_handler

  ld     a,(JOYP_ACTIVE)
  bit    3,a
  jr     z,+                    ;Start button
  ;Pause !
  ld     a,(PAUSE_FLAG)
  bit    2,a
  jr     nz,+			;Can't do nothing if pause forced from gameover
  xor    1
  ld     (PAUSE_FLAG),a
  or     a
  jr     z,++
  ;Enter pause mode
  ld     b,$D0+1-65		;Alphabet
  call   enter_pause
  jr     +
++:
  ;Exit pause mode
  ld     b,$4A			;Blank tile
  call   exit_pause
+:
  ret
