; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

  .INCLUDE "gamekim_aux.asm"
  .INCLUDE "gamekim_vbl.asm"
  .INCLUDE "gamekim_input.asm"

  .DEFINE NUM_FOOD 5

Setup_gamekim:
  di
  call	 screen_off

  ld     hl,$8000               ;Grey tile
  call   greytile

  ld     hl,(:tile_sol1*$4000)+tile_sol1
  ld     de,$8000+(1*16)
  call   loadtiles_auto

  ld     hl,(:tiles_nuage*$4000)+tiles_nuage
  ld     de,$8000+(2*16)
  call   loadtiles_auto

  ld     hl,(:tiles_main1*$4000)+tiles_main1
  ld     de,$8000+(12*16)
  call   loadtiles_auto
  ld     hl,(:tiles_main2*$4000)+tiles_main2
  ld     de,$8000+(37*16)
  call   loadtiles_auto

  ld     hl,(:tiles_priere1*$4000)+tiles_priere1
  ld     de,$8000+(62*16)
  call   loadtiles_auto
  ld     hl,(:tiles_priere2*$4000)+tiles_priere2
  ld     de,$8000+(68*16)
  call   loadtiles_auto

  ld     hl,$8000+(74*16)		;White tile
  ld     bc,$10
  call   clear

  ld     de,$8000+(75*16)
  call   load_bignumbers

  ld     de,$8000+(135*16)
  ld     hl,(:tiles_poisonmini*$4000)+tiles_poisonmini
  call   loadtiles_auto

  ld     de,$8000+(144*16)
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  call   loadtiles_auto

  ;Sprite tiles
  ld     de,$8000+(136*16)
  ld     hl,(:tiles_saucisse*$4000)+tiles_saucisse
  call   loadtiles_auto
  ld     de,$8000+(140*16)
  ld     hl,(:tiles_poulet*$4000)+tiles_poulet
  call   loadtiles_auto
  ld     de,$8000+(144*16)
  ld     hl,(:tiles_tarte*$4000)+tiles_tarte
  call   loadtiles_auto
  ld     de,$8000+(148*16)
  ld     hl,(:tiles_pomme*$4000)+tiles_pomme
  call   loadtiles_auto
  ld     de,$8000+(152*16)
  ld     hl,(:tiles_broccoli*$4000)+tiles_broccoli
  call   loadtiles_auto
  ld     de,$8000+(156*16)
  ld     hl,(:tiles_poison*$4000)+tiles_poison
  call   loadtiles_auto

  ld     de,$8000+($D0*16)
  ld     hl,(:tiles_continuer*$4000)+tiles_continuer
  call   loadtiles_auto
  ld     de,$8000+($E4*16)
  ld     hl,(:tiles_quitter*$4000)+tiles_quitter
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ;Map clouds
  ld     bc,$0502
  ld     a,2
  ld     hl,$9800+(32*4)+14
  call   mapinc
  ld     bc,$0502
  ld     a,2
  ld     hl,$9800+(32*5)+2
  call   mapinc
  ld     bc,$0502
  ld     a,2
  ld     hl,$9800+(32*6)+25
  call   mapinc

  ;Map hand
  ld     bc,$0505
  ld     a,12
  ld     hl,$9800+(32*8)
  call   mapinc

  ;Clear top of the screen (score and lives)
  ld     a,74
  ld     hl,$9800
  ld     b,32*3
-:
  ldi    (hl),a
  dec    b
  jr     nz,-

  ;Map the ground (window)
  ld     a,1
  ld     hl,$9C00+(32*3)
  ld     b,20
-:
  ldi    (hl),a
  dec    b
  jr     nz,-

  ;Map the people (window)
  ld     bc,$0203
  ld     a,62
  ld     hl,$9C00+3
  call   mapinc
  ld     bc,$0203
  ld     a,62
  ld     hl,$9C00+7
  call   mapinc
  ld     bc,$0203
  ld     a,62
  ld     hl,$9C00+11
  call   mapinc
  ld     bc,$0203
  ld     a,62
  ld     hl,$9C00+15
  call   mapinc

  ld     a,$C8
  ld     (HAND_X),a
  xor    a
  ld     (FADEIDX),a
  ld     (BKG_X),a
  ld     (HAND_I),a
  ld     (CLENCH),a
  ld     (TIME_FRAME),a
  ld     (TOADD),a
  ld     (PAUSE_FLAG),a
  ld     (FADEIDX),a
  ld     (POISONNB),a
  dec    a
  ld     (INVINC),a
  ld     a,$D0
  ld     (SPR_PAUSEBAN),a
  ld     hl,RESETX		;For the fadetowhite
  set    0,(hl)

  ld     b,0
  call   setgame

  ld     a,(GAME_FLAGS)
  bit    7,a
  call   nz,ivars

  ld     c,75
  call   disp_score             ;Update score display

  ld     a,135			;Lives tiles
  ld     c,$4A			;Empty tile
  call   update_lives

  ;Init food
  ld     hl,FOODLIST
  ld     de,gk_foodinit
  ld     b,NUM_FOOD
-
  call   get_random
  and    3			;Should be 0~5 but whatever...
  ldi    (hl),a
  ld     a,(de)
  inc    de
  ldi    (hl),a
  ld     a,(de)
  inc    de
  ldi    (hl),a
  xor    a
  ldi    (hl),a
  dec    b
  jr     nz,-

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X
  ld     a,144-32
  ldh    ($4A),a                ;Window scroll Y
  ld     a,7
  ldh    ($4B),a                ;Window scroll X

  ld     a,%11100100            ;SPR0 palette
  ldh    ($48),a
  ld     a,%11110111            ;Turn screen on, BG on, sprites ON 8x16, window ON, tiles at $8000
  ldh    ($40),a
  ld     a,%01010000            ;Vblank + LYC (01010000)
  ldh    ($41),a
  ld     a,%00000011
  ldh    ($FF),a

  call   startsfx

  ld     hl,VBL_HANDLER
  ld     de,VBL_gamekim
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_gamekim
  call   load_RLI

  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei

  ret

gk_foodinit:
.db $25,$30,$12,$50,$52,$60,$2A,$70,$5A,$10 ; X/y pairs

