; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

VBL_gamekim:
  call   fadefromwhite

  ld     a,24
  ldh    ($45),a                ;LYC (clouds)
  xor    a
  ldh    ($43),a                ;X scroll, score bar placement

  call   RAMtoOAM

  ei                            ;Allow RLI to be triggered before RETN

  ld     a,(PAUSE_FLAG)
  or     a
  jr     nz,+++

  ;Game time
  ld     a,(VBLC)
  and    $F
  call   z,anim_paysans         ;People animation every 16 frames

  call   gk_inc_score

  call   check_zero_lives

  ; Make last life blink
  ld     a,(LIVES)
  cp     1
  jr     nz,+
  ld     c,$4A
  ld     a,(VBLC)
  and    $10
  jr     nz,++
  call   clear_lives
  jr     +
++:
  ld     a,135			;Life tile
  call   update_lives
+:

  ld     a,(CLENCH)             ;Dec CLENCH each frame
  or     a
  jr     z,+
  dec    a
  ld     (CLENCH),a
  dec    a
  jr     nz,+
  ld     bc,$0505
  ld     a,12                   ;First tile of hand
  ld     hl,$9800+(32*8)        ;Remap open hand if CLENCH=1 (just before 0)
  call   mapinc_w
+:

  ld     hl,HAND_I              ;Pushed inertia towards 0
  ld     a,(hl)
  or     a
  jr     z,++
  bit    7,a
  jr     z,+
  inc    (hl)                   ;<0 ? inc
  jr     ++
+:
  dec    (hl)                   ;>0 ? dec
++:

  call   gk_update_sprites
  
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ld     b,$B0-16
  ld     hl,TIME_SEC
  ld     e,(hl)
  inc    hl
  ld     d,(hl)
  ld     hl,$9800+64+10
  call   disp_time
  call   gk_render_sprites

  call   inc_time
  
  call   dec_invinc
  
+++:
  call   readinput
  call   gk_input

  call   stepmusic		;For the pause jingle

  ld     hl,VBLC
  inc    (hl)

  ret


RLI_gamekim:
  push   af
  push   hl
  ldh    a,($41)
  bit    2,a
  jr     z,+                    ;LYC match flag ?
  ldh    a,($44)
  cp     24
  jr     nz,++                  ;First (clouds) or second (hand) match ?
  ld     a,$40
  ldh    ($45),a                ;Setup second LYC
  ld     hl,BKG_X
  ld     a,(PAUSE_FLAG)
  or     a
  jr     nz,+++
  ld     a,(VBLC)
  and    3
  jr     nz,+++
  inc    (hl)
+++:
  ld     a,(hl)
  ldh    ($43),a                ;X scroll every 4 frames (clouds)
  pop    hl
  pop    af
  reti
++:
  ld     a,(INVINC)
  and    4
  ld     a,(HAND_X)
  jr     z,++
  ld     a,64			;Outside of screen (invincibility blink)
++:
  add    4
  ldh    ($43),a                ;X scroll (hand)
+:
  pop    hl
  pop    af
  reti
