; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_gameover:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ld     hl,(:tiles_gameover*$4000)+tiles_gameover
  ld     de,$8000+(104*16)
  call   loadtiles_auto

  ld     hl,(:tiles_motdepasse*$4000)+tiles_motdepasse
  ld     de,$8000+(118*16)
  call   loadtiles_auto
  
  ;Load tiles for the trollface or the thumbs up
  ld     a,(WON)
  ld     hl,(:tiles_trollface*$4000)+tiles_trollface
  or     a
  jr     z,+
  ld     hl,(:tiles_thumbsup*$4000)+tiles_thumbsup
+:
  ld     de,$8000+(167*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X
  
  ;Map password banner
  ld     a,118
  ld     de,$9800+(32*11)+2
  ld     hl,(:map_motdepasse*$4000)+map_motdepasse
  call   map
  
  ;Map trollface or thumbs up
  ld     hl,(:map_trollface*$4000)+map_trollface
  ld     a,(WON)
  or     a
  jr     z,+
  ld     hl,(:map_thumbsup*$4000)+map_thumbsup
+:
  ld     a,167
  ld     de,$9866
  call   map

  ld     de,OAMCOPY
  ld     hl,map_gameover
  ld     b,8
  ld     c,47
-:
  ld     a,160                  ;Y
  ld     (de),a
  inc    e
  ld     a,(hl)                 ;X
  inc    hl
  ld     (de),a
  inc    e
  ld     a,(hl)                 ;Tile
  inc    hl
  ld     (de),a
  inc    e
  ld     a,0                    ;Attributes
  ld     (de),a
  inc    e
  dec    b
  jr     nz,-

  call   gen_passwd

  ld     hl,$9806+(15*32)
  ld     de,PASSWD_GEN
  ld     b,32
  call   maptext

  ld     a,%00000000            ;BG palette
  ldh    ($47),a
  ld     a,%11100100            ;SPR0 palette
  ldh    ($48),a
  ld     a,%10010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a
  ld     a,%00010000            ;Vblank
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  ld     a,$A9
  ld     (VBLC),a
  ld     a,$F0
  ld     (YPOS),a
  
  xor    a        		;Reset bastard mode
  ld     (BMODE),a
  ld     (PAUSE_FLAG),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_gameover
  ld     (hl),e
  inc    hl
  ld     (hl),d

  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei

  ret

;X position, tile #...
map_gameover:
.db 42,$68,52,$6A,62,$6C,72,$6E
.db 92,$70,102,$72,112,$6E,122,$74

VBL_gameover:
  ld     a,(VBLC)
  cp     $F0
  jr     c,+
  call   fadefromwhite
+:

  call   RAMtoOAM

  call   readinput
  and    $0F
  jr     z,+
  ld     de,Setup_title
  ld     hl,RESETX
  res    0,(hl)
  jp     Setup_exit_white	;Call+ret = jp
+:

  ;Update Y positions of sprites
  ld     de,OAMCOPY
  ld     c,8
majspr:
  ld     hl,(:Cosinus*$4000)+Cosinus     ;Cos index = Cosinus+((VBLC*2)+(C*5))*2
  push   de
  ld     d,0
  ld     a,(VBLC)
  add    c
  add    c
  add    c
  add    c
  add    c
  sla    a
  and    $7F
  ld     e,a
  add    hl,de
  pop    de

  ld     a,(YPOS)       ;((Cosinus)/8)+YPOS
  ld     b,a
  ld     a,(hl)
  srl    a
  srl    a
  srl    a
  add    b
  ld     (de),a
  inc    de
  inc    de
  inc    de
  inc    de
  dec    c
  jr     nz,majspr
  
  ld     a,(YPOS)       ; Scroll down
  cp     $18
  jr     z,+
  inc    a
  ld     (YPOS),a
+:

  ld     hl,VBLC
  inc    (hl)
  ret