; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

gr_input:
;----------------------------------------------------------------
;User input handling
  ld     hl,PAUSE_FLAG		;Only allow to get out of pause or quit if in pause mode
  bit    0,(hl)
  jp     nz,+++

  ld     a,(JOYP_CURRENT)
  bit    0,a
  jr     z,+                    ;A button (accelerate)
  ld     a,(ROADSPEED)
  cp     $FE
  jr     nc,+
  inc    a
  inc    a
  ld     (ROADSPEED),a
+:

  ld     a,(JOYP_ACTIVE)
  bit    1,a
  jr     z,+                    ;B button (brake)
  ld     a,(ROADSPEED)
  cp     2
  jr     c,+
  dec    a
  dec    a
  ld     (ROADSPEED),a
+:

  xor    a
  ld     (DRIFTING),a

  ld     a,(JOYP_CURRENT)
  bit    4,a                    ;Right
  jr     z,+
  ld     a,(ROADSPEED)		;Prevent car move if speed to low
  cp     20
  jr     c,+
  ld     a,(CAR_X)
  cp     160-28
  jr     z,+
  inc    a
  ld     (CAR_X),a
  ;Drift check
  ld     a,(CAR_PUSH)
  cp     7
  jr     c,+
  ld     (DRIFTING),a
+:

  ld     a,(JOYP_CURRENT)
  bit    5,a                    ;Left
  jr     z,+
  ld     a,(ROADSPEED)		;Prevent car move if speed to low
  cp     20
  jr     c,+
  ld     a,(CAR_X)
  cp     8
  jr     z,+
  dec    a
  ld     (CAR_X),a
  ;Drift check
  ld     a,(CAR_PUSH)
  cp     6
  jr     c,+
  ld     (DRIFTING),a
+:

+++:
  call   pause_b_handler

  ld     a,(JOYP_ACTIVE)
  bit    3,a
  jr     z,+                    ;Start button
  ;Pause !
  ld     a,(PAUSE_FLAG)
  bit    2,a
  jr     nz,+			;Can't do nothing if pause forced from gameover
  xor    1
  or     2
  ld     (PAUSE_FLAG),a
  bit    0,a
  jr     z,++
  ;Enter pause mode
  ;Shut engine up
  xor    a
  ldh    ($17),a
  ;Clear road palettes (or it will blink and seem ugly)
  ;Make palette flags for the edges of the road (interleaved with offsets)
  ld     hl,ROAD_OFFSETS+1
  ld     b,58           	; Number of lines to do
  ld     a,%01010000
-:
  ldi    (hl),a
  inc    hl
  dec    b
  jr     nz,-
  ;Special case for gameroad, enter_pause is called according to PAUSE_FLAG on VBL start
  jr     +
++:
  ;Exit pause mode
  ld     b,GR_T_BLANK		;Blank tile
  call   exit_pause
  call   gr_engsound		;Reset engine sound
  ld     a,%11010000            ;SPR0 palette (special, so done here and not in exit_pause)
  ldh    ($48),a
+:
  ret
