; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

  .INCLUDE "gameroad_aux.asm"
  .INCLUDE "gameroad_vbl.asm"
  .INCLUDE "gameroad_input.asm"

  .DEFINE GR_T_MOUNTAINS 1
  .DEFINE GR_T_ROAD      44
  .DEFINE GR_T_STRIPES   48
  .DEFINE GR_T_NUAGE     76
  .DEFINE GR_T_BLANK     86
  .DEFINE GR_T_BIGNUMS   87
  .DEFINE GR_T_LIFE	 147
  .DEFINE GR_T_CAR1	 148
  .DEFINE GR_T_CAR2	 152
  .DEFINE GR_T_DRIFT	 156
  .DEFINE GR_T_CONE	 158
  .DEFINE GR_T_FOX       162
  .DEFINE GR_T_RONFLEX	 166
  .DEFINE GR_T_CEMENT	 170
  .DEFINE GR_T_ALPHA     158

  .DEFINE GR_TYPE_FOX	   0
  .DEFINE GR_TYPE_CONE     1
  .DEFINE GR_TYPE_RONFLEX  2
  .DEFINE GR_TYPE_CEMENT   3

Setup_gameroad:
  di
  call	 screen_off

  ld     hl,$8000               ;Grey tile
  call   greytile

  ld     hl,(:tiles_mountains*$4000)+tiles_mountains
  ld     de,$8000+(GR_T_MOUNTAINS*16)
  call   loadtiles_auto
  ld     hl,(:tiles_road*$4000)+tiles_road
  ld     de,$8000+(GR_T_ROAD*16)
  call   loadtiles_auto

  ld     hl,(:tiles_rstripes1*$4000)+tiles_rstripes1
  ld     de,$8000+(GR_T_STRIPES*16)
  call   loadtiles_auto
  ld     hl,(:tiles_rstripes2*$4000)+tiles_rstripes2
  ld     de,$8000+((GR_T_STRIPES+7)*16)
  call   loadtiles_auto
  ld     hl,(:tiles_rstripes3*$4000)+tiles_rstripes3
  ld     de,$8000+((GR_T_STRIPES+14)*16)
  call   loadtiles_auto
  ld     hl,(:tiles_rstripes4*$4000)+tiles_rstripes4
  ld     de,$8000+((GR_T_STRIPES+21)*16)
  call   loadtiles_auto

  ld     hl,(:tiles_nuage*$4000)+tiles_nuage
  ld     de,$8000+(GR_T_NUAGE*16)
  call   loadtiles_auto

  ld     hl,$8000+(GR_T_BLANK*16)       ;White tile
  ld     bc,$10
  call   clear

  ld     de,$8000+(GR_T_BIGNUMS*16)
  call   load_bignumbers

  ld     hl,(:tile_carmini*$4000)+tile_carmini
  ld     de,$8000+(GR_T_LIFE*16)
  call   loadtiles_auto

  ld     hl,(:tiles_car*$4000)+tiles_car
  ld     de,$8000+(GR_T_CAR1*16)
  call   loadtiles_auto

  ld     hl,(:tile_drift*$4000)+tile_drift
  ld     de,$8000+(GR_T_DRIFT*16)
  call   loadtiles_auto

  ld     hl,$8000+((GR_T_DRIFT+1)*16)       ;White tile
  ld     bc,$10
  call   clear
  
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000+(GR_T_ALPHA*16)
  call   loadtiles_auto

  ld     hl,(:tiles_cone*$4000)+tiles_cone
  ld     de,$8000+(GR_T_CONE*16)
  call   loadtiles_auto
  ld     hl,(:tiles_fox1*$4000)+tiles_fox1
  ld     de,$8000+(GR_T_FOX*16)
  call   loadtiles_auto
  ld     hl,(:tiles_ronflex*$4000)+tiles_ronflex
  ld     de,$8000+(GR_T_RONFLEX*16)
  call   loadtiles_auto
  ld     hl,(:tiles_cement*$4000)+tiles_cement
  ld     de,$8000+(GR_T_CEMENT*16)
  call   loadtiles_auto
  
  ld     de,$8000+($DA*16)
  ld     hl,(:tiles_continuer*$4000)+tiles_continuer
  call   loadtiles_auto
  ld     de,$8000+($EE*16)
  ld     hl,(:tiles_quitter*$4000)+tiles_quitter
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ld     a,GR_T_MOUNTAINS
  ld     de,$9800+(32*7)
  ld     hl,(:map_mountains*$4000)+map_mountains
  call   map

  ld     a,GR_T_ROAD
  ld     de,$9800+(32*11)+2
  ld     hl,(:map_road*$4000)+map_road
  call   map

  ;Map clouds
  ld     bc,$0502
  ld     a,GR_T_NUAGE
  ld     hl,$9800+(32*3)+3
  call   mapinc
  ld     bc,$0502
  ld     a,GR_T_NUAGE
  ld     hl,$9800+(32*4)+10
  call   mapinc
  ld     bc,$0502
  ld     a,GR_T_NUAGE
  ld     hl,$9800+(32*3)+$14
  call   mapinc

  ;Clear top of the screen (score and lives)
  ld     a,GR_T_BLANK
  ld     hl,$9800
  ld     b,32*3
-:
  ldi    (hl),a
  dec    b
  jr     nz,-

  xor    a
  ld     (BKG_X),a
  ld     (TOADD),a
  ld     (STRIPE),a
  ld     (ROADSPEED),a
  ld     (CAR_PUSH),a
  ld     (CAR_X_LOW),a
  ld     (PAUSE_FLAG),a
  ld     (FADEIDX),a
  ld     a,$DA		
  ld     (SPR_PAUSEBAN),a
  ld     a,1
  ld     (ANIMAL_Y),a
  ld     a,$80
  ld     (ROAD_X),a
  ld     (ROAD_GOAL),a
  ld     hl,RESETX
  set    0,(hl)
  ld     a,40
  ld     (ANIMAL_XVIS),a
  ld     a,$80
  ld     (APPEAR_DELTA),a

  ld     b,1
  call   setgame

  ld     a,(GAME_FLAGS)
  bit    7,a
  call   nz,ivars

  ld     de,$7FF
  ld     hl,ROAD_GOAL_DELTA
  rst    $10

  ld     a,64
  ld     (CAR_X),a
  ld     a,64
  ld     (ANIMAL_X),a
  ld     a,3
  ld     (ANIMAL_TYPE),a

  ld     c,GR_T_BIGNUMS
  call   disp_score             ;Update score display

  ld     a,GR_T_LIFE		;Lives tiles
  ld     c,GR_T_BLANK
  call   update_lives

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11100100            ;BG palette
  ldh    ($47),a
  ld     a,%11010000            ;SPR0 palette
  ldh    ($48),a
  ld     a,%11010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a
  ld     a,%01010000            ;Vblank + LYC
  ldh    ($41),a
  ld     a,%00000011
  ldh    ($FF),a

  call   startsfx
  call   gr_engsound

  ld     hl,VBL_HANDLER
  ld     de,VBL_gameroad
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_gameroad
  call   load_RLI

  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei

  ret

gr_engsound:			;Init engine sound (continuous)
  ld     a,%10000000
  ldh    ($16),a
  ld     a,%01110000
  ldh    ($17),a
  xor    a
  ldh    ($18),a
  ld     a,%10000010
  ldh    ($19),a
  ret
