; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

VBL_gameroad:
  ld     hl,PAUSE_FLAG
  bit    0,(hl)
  ld     a,%01010000            ;BG palette
  jp     nz,+
  ld     a,%11100100            ;BG palette
+:
  ldh    ($47),a

  call   fadefromwhite

  ld     a,%01010000            ;Vblank + LYC
  ldh    ($41),a
  ld     a,24
  ldh    ($45),a                ;LYC (clouds/mountains: 24-1)
  xor    a
  ldh    ($43),a                ;X scroll, score bar placement

  call   RAMtoOAM

  ei                            ;Allow the RLI to be triggered before the RETN

  ld     hl,PAUSE_FLAG
  ld     a,(hl)
  and    3                      
  cp     3
  jr     nz,+
  res    1,(hl)
  ld     b,$D0+1-79		;Alphabet
  call   enter_pause
  jp     +++
+:
  ld     a,(hl)
  and    %101
  jp     nz,+++
  
  ld     a,(SLOWACC)		;Init PALACC for this frame with a slow "SPEEDACC" inc
  cpl
  srl    a
  ld     (PALACC),a
  ld     a,70			;Init horizon lines concentration
  ld     (PALSPEED),a

  call   check_zero_lives

  ; Make last life blink
  ld     a,(LIVES)
  cp     1
  jr     nz,+
  ld     c,GR_T_BLANK
  ld     a,(VBLC)
  and    $10
  jr     nz,++
  call   clear_lives
  jr     +
++:
  ld     a,GR_T_LIFE		;Life tile
  call   update_lives
+:

  ld     b,$BE-16
  ld     hl,TIME_SEC
  ld     e,(hl)
  inc    hl
  ld     d,(hl)
  ld     hl,$9800+64+10
  call   disp_time

  call   gr_inc_score		;Shared routine
  call   gr_map_strip
  call   gr_collision
  call   inc_time

  ld     a,(ROADSPEED) 		;Friction
  or     a
  jr     z,+
  dec    a
  ld     (ROADSPEED),a
+:

  ld     b,a
  srl    b
  ld     a,(SPEEDACC)           ;Road stripes animation
  add    b
  ld     (SPEEDACC),a
  jr     nc,+
  ld     hl,STRIPE
  inc    (hl)
+:
  srl    b
  srl    b
  ld     a,b
  srl    b
  sub    b
  ld     b,a
  ld     a,(SLOWACC)
  add    b
  ld     (SLOWACC),a

  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  call   gr_update_sprites
  call   gr_sound
  call   gr_update_road
  call   gr_render_sprites

+++:
  call   readinput
  call   gr_input

  call   stepmusic		;For the pause jingle

  ld     hl,VBLC
  inc    (hl)

  ret

;This needs to be ultra fast !
RLI_gameroad:
  push   af
  push   hl
  ldh    a,($41)
  bit    2,a
  jr     z,+                    ;LYC match flag ?
  ldh    a,($44)
  cp     24
  jr     nz,++                  ;First (clouds/mountains) or second (road) match ?
  ;Clouds + mountains
  ld     a,$3F+22
  ldh    ($45),a                ;Setup second LYC
  ld     a,(BKG_X)
  ldh    ($43),a                ;X scroll every 4 frames (clouds)
  pop    hl
  pop    af
  reti
++
  ;Road start
  ld     a,%00011000            ;Vblank + Hblank
  ldh    ($41),a
  pop    hl
  pop    af
  reti
+:
  and    3
  jr     nz,+
  ;Road (X offset)
  ldh    a,($44)
  sub    $3F+22
  ld     h,$DE
  sla    a
  ld     l,a
  ldi    a,(hl)
  ldh    ($43),a
  ;Road (palette)
  ld     a,(hl)
  ldh    ($47),a

+:
  pop    hl
  pop    af
  reti
