; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

clearsprites:
  call   wait_vbl
  ld     hl,$FE00               ;Clear OAM
  ld     b,40*4
clspr:
  ld     (hl),$00
  inc    l                      ;Avoid GB hardware bug
  dec    b
  jr     nz,clspr
  ret
  
greytile:
  ld     b,8
  xor    a
-:
  dec    a
  ldi    (hl),a
  xor    a
  ldi    (hl),a
  dec    b
  jr     nz,-
  ret
  
;----------------------------------------------------------------
;Clears VRAM to zero HL -> HL+BC
clear_w:
  xor    a
  call   wait_write
  ldi    (hl),a
  dec    bc
  ld     a,c
  or     b
  jr     nz,clear_w
  ret
  
;HL = pointer to OAMCOPY
make8x16sprite:
  ;Left sprite
  ld     a,(SPR16_Y)
  ldi    (hl),a         ; Y
  ld     a,(SPR16_X)
  ldi    (hl),a         ; X
  ld     a,(SPR16_N)
  ldi    (hl),a         ; Tile
  ld     a,(SPR16_A)
  ldi    (hl),a         ; Attribs
  ;Right sprite
  ld     a,(SPR16_Y)
  ldi    (hl),a         ; Y
  ld     a,(SPR16_X)
  add    8
  ldi    (hl),a         ; X
  ld     a,(SPR16_N)
  inc    a              ; + 2 tiles
  inc    a
  ldi    (hl),a         ; Tile
  ld     a,(SPR16_A)
  ldi    (hl),a         ; Attribs
  ret


load_bignumbers:
  ld     hl,(:tiles_big0*$4000)+tiles_big0
  call   loadtiles_auto
  ld     hl,(:tiles_big1*$4000)+tiles_big1
  call   loadtiles_auto
  ld     hl,(:tiles_big2*$4000)+tiles_big2
  call   loadtiles_auto
  ld     hl,(:tiles_big3*$4000)+tiles_big3
  call   loadtiles_auto
  ld     hl,(:tiles_big4*$4000)+tiles_big4
  call   loadtiles_auto
  ld     hl,(:tiles_big5*$4000)+tiles_big5
  call   loadtiles_auto
  ld     hl,(:tiles_big6*$4000)+tiles_big6
  call   loadtiles_auto
  ld     hl,(:tiles_big7*$4000)+tiles_big7
  call   loadtiles_auto
  ld     hl,(:tiles_big8*$4000)+tiles_big8
  call   loadtiles_auto
  ld     hl,(:tiles_big9*$4000)+tiles_big9
  call   loadtiles_auto
  ret

;a=first tile
;bc=width/height
;hl=vram
mapinc:
  push   de
  push   hl
mapib:
  ld     d,b
mapia:
  ldi    (hl),a
  inc    a
  dec    d
  jr     nz,mapia
  pop    hl
  ld     de,32
  add    hl,de
  push   hl
  dec    c
  jr     nz,mapib
  pop    hl
  pop    de
  ret
  
;a=first tile
;bc=width/height
;hl=vram
mapinc_w:
  push   bc
  push   af
  ldh    a,($40)
  ld     b,a
  pop    af
  bit    7,b
  pop    bc		; Bitch.
  jr     z,mapinc

  push   de
  push   hl
--:
  ld     d,b
-:

  push   af		; Wait for the CPU to leave the VRAM alone (not often !)
---:
  ldh    a,($41)
  and    3
  cp     3
  jr     nz,---
---:
  ldh    a,($41)
  and    3
  cp     3
  jr     z,---
  pop    af

  ldi    (hl),a
  inc    a
  dec    d
  jr     nz,-
  pop    hl
  ld     de,32
  add    hl,de
  push   hl
  dec    c
  jr     nz,--
  pop    hl
  pop    de
  ret

;de=text
;hl=vram
;To call each frame
mapdialog:
  ld     a,(WRITEWAIT)
  bit    7,a			;Write end flag (speed up)
  ret    nz
  inc    a
  ld     (WRITEWAIT),a
  cp     3			;Write speed
  ret    nz
  xor    a
  ld     (WRITEWAIT),a

  ld     hl,WRITETPTR
  ldi    a,(hl)                 ;DE=(WRITETPTR)
  ld     e,(hl)
  ld     d,a

  ld     hl,WRITEVPTR
  ldi    a,(hl)                 ;HL=(WRITEVPTR)
  ld     l,(hl)
  ld     h,a

  push   hl
-:
  ld     a,(de)
  cp     $FF
  jr     nz,+
  ld     a,$80			;Write end flag
  ld     (WRITEWAIT),a
  pop    hl
  ret
+:
  cp     $FE
  jr     nz,+
  pop    hl
  push   de
  ld     a,l
  and    $E0
  ld     l,a
  ld     de,33
  add    hl,de
  pop    de
  push   hl
  inc    de
  jr     -
+:
  sub    32
  call   wait_write
  ldi    (hl),a
  inc    de
  ld     a,d                    ;(WRITETPTR)=DE
  ld     (WRITETPTR),a
  ld     a,e
  ld     (WRITETPTR+1),a
  ld     a,h                    ;(WRITEVPTR)=HL
  ld     (WRITEVPTR),a
  ld     a,l
  ld     (WRITEVPTR+1),a
  pop    hl
  ld     hl,fxscore		;Selection beep
  call   playsfx
  ret


;de=text
;hl=vram
;b=ascii index (32)
maptext:
  push   hl
maptextlp:
  ld     a,(de)
  cp     $FF
  jr     nz,+
  pop    hl
  ret
+:
  cp     $FE
  jr     nz,+
  pop    hl
  push   de
  ld     de,32
  add    hl,de
  pop    de
  push   hl
  inc    de
  jr     maptextlp
+:
  sub    b
  
  push   af		;Wait for VRAM again...
  ldh    a,($40)
  bit    7,a
  jr     z,+
---:
  ldh    a,($41)
  and    3
  cp     3
  jr     nz,---
---:
  ldh    a,($41)
  and    3
  cp     3
  jr     z,---
+:
  pop    af

  ldi    (hl),a
  inc    de
  jr     maptextlp

;de=text
;hl=vram
;b=limit
maptextlimit:
  push   hl
maptextlilpr:
  ld     c,0
maptextlilp:
  ld     a,(de)
  cp     $FF
  jr     nz,+
  pop    hl
  ret
+:
  ld     a,b
  cp     c
  jr     nz,+
  pop    hl
  push   de
  ld     de,32
  add    hl,de
  pop    de
  push   hl
  jr     maptextlilpr
+:
  ld     a,(de)
  sub    32
  call   wait_write
  ldi    (hl),a
  inc    de
  inc    c
  jr     maptextlilp

;a=first tile
;hl=map
;de=vram
map:
  ld     (MAP_FIRST),a
  ldi    a,(hl)
  ld     (MAP_W),a
  ldi    a,(hl)
  ld     c,a
  push   de

mapb:
  ld     a,(MAP_W)
  ld     b,a
mapa:
  ldi    a,(hl)
  push   hl
  ld     hl,MAP_FIRST
  add    (hl)
  pop    hl
  call   wait_write
  ld     (de),a
  inc    de
  dec    b
  jr     nz,mapa

  pop    de
  push   hl
  ld     hl,32
  add    hl,de
  push   hl
  pop    de
  pop    hl
  push   de

  dec    c
  jr     nz,mapb
  pop    de
  ret

wait_vbl:
  ldh    a,($40)
  rlca
  ret    nc
wait_vbll:
  ldh    a,($44)                ;Wait for VBL start (first line out of screen, Y=144)
  cp     144
  jr     nz,wait_vbll
  ret

clearbkg:
  ld     de,32*32               ;Clear the BG's map
  ld     hl,$9800
-:
  xor    a
  ldi    (hl),a
  dec    de
  ld     a,e
  or     d
  jr     nz,-
  
  ld     de,32*32               ;Clear the windows' map
  ld     hl,$9C00
-:
  xor    a
  ldi    (hl),a
  dec    de
  ld     a,e
  or     d
  jr     nz,-
  ret
  
writeDE:
  ld     a,d
  swap   a
  and    $F
  call   checkhex
  add    16
  call   wait_write
  ldi    (hl),a
  ld     a,d
  and    $F
  call   checkhex
  add    16
  call   wait_write
  ldi    (hl),a
  ld     a,e
  swap   a
  and    $F
  call   checkhex
  add    16
  call   wait_write
  ldi    (hl),a
  ld     a,e
  and    $F
  call   checkhex
  add    16
  call   wait_write
  ldi    (hl),a
  ret

checkhex:
  cp     $0A
  ret    c
  add    7
  ret

wait_write:
  push   af
-:
  ldh    a,($41)
  bit    1,a
  jr     nz,-
  pop    af
  ret
  
wait_hblank:
  push   af
-:
  ldh    a,($41)
  and    3
  jr     z,-
-:
  ldh    a,($41)
  and    3
  jr     nz,-
  pop    af
  ret

RAMtoOAM:
  ;Copies DMA routine to HRAM
  ld     hl,doDMA
  ld     de,$FF80
  ld     b,doDMAend-doDMA
ldhram:
  ldi    a,(hl)
  ld     (de),a
  inc    de
  dec    b
  jr     nz,ldhram
  call   $FF80          ;Execute DMA
  ret
  
doDMA:
   ld    a,$DF
   ldh   ($46),a        ;Start DMA, start=$DF00
   ld    a,($DF00)
   cp    160
   jr    nz,+
   ld    a,$C2
   ld    (ISEMULATOR),a
+:
   ld    a,$28          ;Wait for DMA to be done...
  wait:
   dec   a
   jr    nz,wait
   ret
doDMAend:

   .INCLUDE "loadtile.asm"

disp_DE_big:
  ld     a,d
  swap   a
  call   disp_DE_num
  ld     a,d
  call   disp_DE_num
  ld     a,e
  swap   a
  call   disp_DE_num
  ld     a,e
  call   disp_DE_num
  ret
  
disp_DE_num:
  and    $f
  call   mul6
  add    c
  push   bc
  ld     bc,$0203
  push   hl
  call   mapinc_w
  pop    hl
  inc    hl
  inc    hl
  pop    bc
  ret
