; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_intro:
  di
  call	 screen_off

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load mini logo
  ld     hl,(:tiles_earth*$4000)+tiles_earth
  ld     de,$8000+(96*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map earth on window
  ld     a,96
  ld     de,$9C00+3+64
  ld     hl,(:map_earth*$4000)+map_earth
  call   map

  ld     a,124
  ld     (WINDOW_Y),a

  xor    a
  ldh    ($42),a                ;Scroll Y
  ld     (BKG_Y),a
  ldh    ($43),a                ;Scroll X

  ld     a,(WINDOW_Y)
  ldh    ($4A),a                ;Window Y
  ld     a,7
  ldh    ($4B),a                ;Window X

  ld     a,%00011011
  ldh    ($47),a                ;BG palette
  ldh    ($48),a                ;SPR0 palette

  ld     a,%11110001            ;Turn screen on, BG on, sprites OFF, window ON, tiles at $8000, window map at $9C00
  ldh    ($40),a

  ld     a,%00011000            ;Vblank+RLI
  ldh    ($41),a
  ld     a,%00000011
  ldh    ($FF),a

  ld     de,$9800+(32*12)+2
  ld     hl,Scroll_MapPtr       ;CREDITS_MAPPTR
  rst    $10
  
  ld     de,text_intro
  ld     hl,Scroll_TxtPtr       ;CREDITS_TXTPTR = text_credits
  rst    $10
  
  ld     de,Setup_title
  ld     hl,Scroll_JumpTo
  rst    $10

  ld     hl,VBL_HANDLER
  ld     de,VBL_intro
  ld     (hl),e
  inc    hl
  ld     (hl),d
  
  ld     hl,RLI+1
  ld     de,RLI_intro
  ld     (hl),e
  inc    hl
  ld     (hl),d
  xor    a

  xor    a
  ld     (VBLC),a

  ld     a,16*6+12
  ld     (Scroll_Fade_End),a

  ld     de,music_intro
  ld     hl,Sot_Music
  rst    $10
  call   setupmusic
  
  ld     a,Sot_F_Play | Sot_F_Turnoff
  ld     (Sot_Flags),a

  ei
  ret


VBL_intro:
  ld     a,$FF
  ldh    ($47),a                ;BG palette
  
  call   readinput              ;Go to title screen if button press
  and    $0F
  jr     z,+
  call   stopmusic
  call   Setup_title
  ret
+:

  ld     a,(FRAME)              ;Update earth scroll every 64 frames
  and    $3F
  jr     nz,+
  ld     a,(WINDOW_Y)
  dec    a
  ld     (WINDOW_Y),a
  ldh    ($4A),a                ;Window Y
+:

  ld     a,(FRAME)              ;Update text scroll every 4 frames
  and    3
  jr     nz,+
  call   update_scroller
+:

  call   stepmusic

  ret
  
RLI_intro:
  push   de
  push   hl
  ldh    a,($44)
  ld     hl,Scroll_Fade_End
  cp     (hl)
  jr     nc,+
  swap   a                      ;LY < Scroll_Fade_End: LY/16 = palette LUT
  and    $F
  ld     hl,tbl_fadeini
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti
+:                              ;LY > Scroll_Fade_End: normal palette
  ld     a,%00011011
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti

text_cleari:
.db "                ",$FF

text_intro:
.db "Plan|te terre.",$FF
.db "Date:",$FF
.db "On s'en fout.",$FF
.db $FF

.db "La surpopulation",$FF
.db "de connards est",$FF
.db "un probl|me",$FF
.db "grandissant.",$FF
.db "L'ordre",$FF
.db "supr}me des",$FF
.db "connards, a",$FF
.db "d{cid{ d'{lire",$FF
.db "un nouveau Super",$FF
.db "Connard afin de",$FF
.db "reprendre",$FF
.db "controle sur la",$FF
.db "situation.",$FF
.db $FF
.db "Pour cela, l'{lu",$FF
.db "devra affronter",$FF
.db "3 des pires",$FF
.db "connards de ce",$FF
.db "monde, dans",$FF
.db "leurs domaines",$FF
.db "de connardise",$FF
.db "respectifs, pour",$FF
.db "prouver ses",$FF
.db "capacit{s ~",$FF
.db "foutre la merde,",$FF
.db "a nier les droits",$FF
.db "de l'homme, et",$FF
.db "ruiner",$FF
.db "l'environnement.",$FF
.db $FF,$FF,$FF
.db "Cet {lu,",$FF
.db "c'est vous.",$FF
.db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$00

tbl_fadeini:
.db %11111111,%10101011,%01011011,%00011011,%01011011,%10101011,%11111111
