; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_introcamp:
  di
  call	 screen_off

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load Hitler's face
  ld     hl,(:tiles_portrait_hitler*$4000)+tiles_portrait_hitler
  ld     de,$8000+(96*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map face on window
  ld     a,96
  ld     de,$9C00+128
  ld     hl,(:map_portrait_hitler*$4000)+map_portrait_hitler
  call   map

  call   intro_shared

  ld     de,(:text_introcamp*$4000)+text_introcamp
  ld     hl,Scroll_TxtPtr
  rst    $10
  
  ld     de,Setup_sbcamp
  ld     hl,Scroll_JumpTo
  rst    $10

  ld     hl,VBL_HANDLER
  ld     de,VBL_introcamp
  ld     (hl),e
  inc    hl
  ld     (hl),d
  
  ld     hl,RLI+1
  ld     de,RLI_introcamp
  ld     (hl),e
  inc    hl
  ld     (hl),d
  xor    a

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a
  
  ld     a,16*6+8
  ld     (Scroll_Fade_End),a

  ei
  ret
  
  
  
Setup_sbcamp:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ld     hl,(:tiles_gc_sym0*$4000)+tiles_gc_sym0
  ld     de,$8000+(136*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym1*$4000)+tiles_gc_sym1
  ld     de,$8000+(137*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym2*$4000)+tiles_gc_sym2
  ld     de,$8000+(138*16)
  call   loadtiles_auto
  ld     hl,(:tiles_gc_sym3*$4000)+tiles_gc_sym3
  ld     de,$8000+(139*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map icons
  ld     a,136
  ld     ($9800+(32*2)+3),a
  ld     a,137
  ld     ($9800+(32*6)+3),a
  ld     a,138
  ld     ($9800+(32*9)+3),a
  ld     a,139
  ld     ($9800+(32*12)+3),a

  ld     de,txt_sbcamp
  ld     hl,$9800+(1*32)+7
  ld     b,32
  call   maptext

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11111111
  ldh    ($47),a                ;BG palette
  ld     a,%11100100
  ldh    ($48),a                ;SPR0 palette

  ld     a,%10010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00010000            ;Vblank only
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_sbcamp
  ld     (hl),e
  inc    hl
  ld     (hl),d

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a

  ei
  ret

VBL_introcamp:
  ld     a,(FADEIDX)
  cp     16
  jr     nz,+
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
+:
  call   fadefromwhite
  ld     a,(FRAME)              ;Update scroll every 4 frames
  and    3
  jr     nz,+
  call   update_scroller
+:
  call   readinput
  and    $0F
  jr     z,+
  call   Setup_sbcamp
+:
  ret
  


VBL_sbcamp:
  call   fadefromwhite
  call   readinput
  and    $0F
  jr     z,+
  call   Setup_gamecamp
+:
  ret
  

  
RLI_introcamp:
  ld     a,(FADEIDX)
  cp     16
  jr     nz,++
  push   de
  push   hl
  ldh    a,($44)
  ld     hl,Scroll_Fade_End	;Really "Start" but hey... less RAM.
  cp     (hl)
  jr     c,+
  sub    (hl)
  sra    a
  sra    a
  sra    a
  ld     hl,tbl_fadeinik
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
++:
  reti
+:                              ;LY > Scroll_Fade_End: normal palette
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti
