; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_introkim:
  di
  call	 screen_off

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load Kim Jong Un's face
  ld     hl,(:tiles_portrait_kim*$4000)+tiles_portrait_kim
  ld     de,$8000+(96*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map face on window
  ld     a,96
  ld     de,$9C00+128
  ld     hl,(:map_portrait_kim*$4000)+map_portrait_kim
  call   map

  call   intro_shared
  
  ld     de,(:text_introkim*$4000)+text_introkim
  ld     hl,Scroll_TxtPtr
  rst    $10
  
  ld     de,Setup_sbkim
  ld     hl,Scroll_JumpTo
  rst    $10

  ld     hl,VBL_HANDLER
  ld     de,VBL_introkim
  ld     (hl),e
  inc    hl
  ld     (hl),d
  
  ld     hl,RLI+1
  ld     de,RLI_introkim
  ld     (hl),e
  inc    hl
  ld     (hl),d
  xor    a

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a
  
  ld     a,16*6+8
  ld     (Scroll_Fade_End),a

  ei
  ret
  
  
  
Setup_sbkim:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load food icons
  ld     de,$8000+(136*16)
  ld     hl,(:tiles_saucisse*$4000)+tiles_saucisse
  call   loadtiles_auto
  ld     de,$8000+(140*16)
  ld     hl,(:tiles_poulet*$4000)+tiles_poulet
  call   loadtiles_auto
  ld     de,$8000+(144*16)
  ld     hl,(:tiles_tarte*$4000)+tiles_tarte
  call   loadtiles_auto
  ld     de,$8000+(148*16)
  ld     hl,(:tiles_pomme*$4000)+tiles_pomme
  call   loadtiles_auto
  ld     de,$8000+(152*16)
  ld     hl,(:tiles_broccoli*$4000)+tiles_broccoli
  call   loadtiles_auto
  ld     de,$8000+(156*16)
  ld     hl,(:tiles_poison*$4000)+tiles_poison
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ;Map icons
  ld     a,$38
  ld     (SPR16_X),a
  ld     de,iksb_sprites
  ld     b,6
  ld     hl,OAMCOPY
-:
  ld     a,(de)
  inc    de
  ld     (SPR16_N),a
  ld     a,(de)
  inc    de
  ld     (SPR16_Y),a
  xor    a
  ld     (SPR16_A),a
  call   make8x16sprite
  dec    b
  jr     nz,-

  call   RAMtoOAM

  ld     de,txt_sbkim1
  ld     hl,$9800+(3*32)+9
  ld     b,32
  call   maptext

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11111111
  ldh    ($47),a                ;BG palette
  ld     a,%11100100
  ldh    ($48),a                ;SPR0 palette

  ld     a,%10010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00010000            ;Vblank only
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_sbkim
  ld     (hl),e
  inc    hl
  ld     (hl),d

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a

  ei
  ret
  
iksb_sprites:
  .db $88	;#
  .db $28-8     ;Y
  .db $8C	;#
  .db $38-7     ;Y
  .db $90	;#
  .db $48-6     ;Y
  .db $94	;#
  .db $58-5     ;Y
  .db $98	;#
  .db $68-4     ;Y
  .db $9C	;#
  .db $78+5     ;Y

VBL_introkim:
  ld     a,(FADEIDX)
  cp     16
  jr     nz,+
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
+:
  call   fadefromwhite
  ld     a,(FRAME)              ;Update scroll every 4 frames
  and    3
  jr     nz,+
  call   update_scroller
+:
  call   readinput
  and    $0F
  jr     z,+
  ld     de,Setup_sbkim
  call   Setup_exit_white
+:
  ret
  


VBL_sbkim:
  call   fadefromwhite
  call   readinput
  and    $0F
  jr     z,+
  ld     de,Setup_gamekim
  call   Setup_exit_white
+:
  ret
  

  
RLI_introkim:
  ld     a,(FADEIDX)
  cp     16
  jr     nz,++
  push   de
  push   hl
  ldh    a,($44)
  ld     hl,Scroll_Fade_End	;Really "Start" but hey... less RAM.
  cp     (hl)
  jr     c,+
  sub    (hl)
  sra    a
  sra    a
  sra    a
  ld     hl,tbl_fadeinik
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
++:
  reti
+:                              ;LY > Scroll_Fade_End: normal palette
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
  pop    hl
  pop    de
  reti

tbl_fadeinik:
.db %11100100,%10100100,%10010100,%01010100,%00000000
