; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

Setup_introroad:
  di
  call	 screen_off

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load Joseph's face
  ld     hl,(:tiles_portrait_joseph*$4000)+tiles_portrait_joseph
  ld     de,$8000+(96*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map face on window
  ld     a,96
  ld     de,$9C00+128
  ld     hl,(:map_portrait_joseph*$4000)+map_portrait_joseph
  call   map

  call   intro_shared
  
  ld     de,(:text_introroad*$4000)+text_introroad
  ld     hl,Scroll_TxtPtr
  rst    $10
  
  ld     de,Setup_sbroad
  ld     hl,Scroll_JumpTo
  rst    $10

  ld     hl,VBL_HANDLER
  ld     de,VBL_introroad
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_introkim
  call   load_RLI

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a
  
  ld     a,16*6+8
  ld     (Scroll_Fade_End),a

  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei
  ret
  
  
  
Setup_sbroad:
  di
  call   wait_vbl
  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load icons
  ld     de,$8000+(136*16)
  ld     hl,(:tiles_cone*$4000)+tiles_cone
  call   loadtiles_auto
  ld     de,$8000+(140*16)
  ld     hl,(:tiles_fox1*$4000)+tiles_fox1
  call   loadtiles_auto
  ld     de,$8000+(144*16)
  ld     hl,(:tiles_ronflex*$4000)+tiles_ronflex
  call   loadtiles_auto
  ld     de,$8000+(148*16)
  ld     hl,(:tiles_cement*$4000)+tiles_cement
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ;Map icons
  ld     a,$38
  ld     (SPR16_X),a
  ld     de,irsb_sprites
  ld     b,4
  ld     hl,OAMCOPY
-:
  ld     a,(de)
  inc    de
  ld     (SPR16_N),a
  ld     a,(de)
  inc    de
  ld     (SPR16_Y),a
  xor    a
  ld     (SPR16_A),a
  call   make8x16sprite
  dec    b
  jr     nz,-

  call   RAMtoOAM

  ld     de,txt_sbroad
  ld     hl,$9800+(5*32)+9
  ld     b,32
  call   maptext

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11111111
  ldh    ($47),a                ;BG palette
  ld     a,%11100100
  ldh    ($48),a                ;SPR0 palette

  ld     a,%10010111            ;Turn screen on, BG on, sprites ON 8x16, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00010000            ;Vblank only
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_sbroad
  ld     (hl),e
  inc    hl
  ld     (hl),d

  xor    a
  ld     (VBLC),a
  ld     (FADEIDX),a

  ei
  ret
  
irsb_sprites:
  .db 144	;#
  .db $38-8     ;Y
  .db 140	;#
  .db $48-7     ;Y
  .db 136	;#
  .db $58-6     ;Y
  .db 148	;#
  .db $70-5     ;Y

VBL_introroad:
  ld     a,(FADEIDX)
  cp     16
  jr     nz,+
  ld     a,%11100100
  ldh    ($47),a                ;BG palette
+:
  call   fadefromwhite
  ld     a,(FRAME)              ;Update scroll every 4 frames
  and    3
  jr     nz,+
  call   update_scroller
+:
  call   readinput
  and    $0F
  jr     z,+
  ld     de,Setup_sbroad
  call   Setup_exit_white
+:
  ret



VBL_sbroad:
  call   fadefromwhite
  call   readinput
  and    $0F
  jr     z,+
  ld     de,Setup_gameroad
  call   Setup_exit_white
+:
  ret
