;      __________________________________________________
;    /                  SUPER CONNARD V1                 \
;   /  ,-----------------------------------------------,  \
;   | /         Code et gfx par shaman Furrtek          \ |
;   |/        Musique et fx par docteur Don Ratta        \|
;   /         Beta-testing par agent special Dyak         \
;   |                 In Gameboy We Trust                 |
;   \            Creative Commons BY-NC-SA 2013           /
;    \              Derniere rev: 07/05/2013             /
;     '-------------------------------------------------'

.ROMDMG                         ;DMG sans features Super Gameboy
.NAME "SUPERCONNARD"            ;Nom du ROM
.CARTRIDGETYPE 0                ;ROM only
.RAMSIZE 0                      ;Pas de RAM externe
.COMPUTEGBCHECKSUM              ;WLA-DX fera checksum lui-mme (ncessaire sur une vraie GB)
.COMPUTEGBCOMPLEMENTCHECK       ;WLA-DX fera code de verif du header (ncessaire sur une vraie GB)
.LICENSEECODENEW "00"           ;Code de license Nintendo, j'en ai pas !
.EMPTYFILL $00                  ;Padding avec des 0

.MEMORYMAP
SLOTSIZE $4000
DEFAULTSLOT 0
SLOT 0 $0000
SLOT 1 $4000
.ENDME

.ROMBANKSIZE $4000              ;Deux banks de 16Ko
.ROMBANKS 2

.BANK 0 SLOT 0

;.DEFINE VERBOSE 1

.STRUCT FOOD
TYPE   db               ;0~4:aliments 5:poison, bit 7 = grabbed, bit 6 = hit ground ok (utilise pour le "prrt" chute)
YPOS   db               ;Position Y
XPOS   db               ;Position X
XOFS   db		;Position X ajoutee (cos)
.ENDST

.STRUCT WAGON
LOCO_STEP DB		;bits 3~0: 0:en attente, 1,2,3:travel - bits 6~4: type (0,1,2,3) - bit 7: loco/wagon
LOCO_GOALX DB
LOCO_GOALY DB
LOCO_X DB
LOCO_Y DB
.ENDST

.ENUM $C000 EXPORT
;System
A_REG DB
B_REG DB
FRAME DB
VBLC  DB
RAND8 DB

VBL_HANDLER DW          ;Pointeur routine VBL (0 = rien)
PREVJP DB               ;Valeur prcdente joypad
JOYP_ACTIVE DB          ;Fronts montants
JOYP_CURRENT DB         ;Appuis continus

SPR16_Y DB              ;Utilise par make8x16sprite
SPR16_X DB
SPR16_N DB
SPR16_A DB

KCODE_BUF DS 20		;Buffer pour la detection du Konami code
BMODE DB		;Mode batard (1 vie) ?

SPR_PAUSEBAN DB		;Numero du premier tile pour les banieres pause (continuer/quitter)
WON DB			;Pour afficher la trollface ou thumbs up dans le gameover

FADEIDX DB              ;Pointeur fadein/fadeout
TOSETUP DW              ;Routine  lancer aprs fadein/fadeout

RLI DS 3		;Utilise pour faire JP xx xx

ISEMULATOR DB           ;!= 0 si mulateur

FRAME_ANIM DB
YPOS DB
YSPEED DB
BKG_X DB
BKG_Y DB

STRETCH DB
CURMENU DB              ;Curseur du title menu (0~2)

WORLDSEL DB             ;Curseur sur la carte du monde

WRITEWAIT DB 		;Compteur de temps pour l'affichage en typewriter + flag dans le bit 7
WRITETPTR DW		;Pointeur texte
WRITEVPTR DW            ;Pointeur VRAM

RESETX DB		;Flag pour demander au fader de remettre le X du BG a 0
PAUSE_FLAG DB		;bit 0 = en pause, bit 1 = enter_pause a executer

GAME_FLAGS DB		;Numero du jeu pour lequel generer le pass (0~2), bit 7=1 si init depuis un pass

PASSWD_BS DS 5		;Bitstream
PASSWD_GEN DS 8+1       ;Password gnr, $FF
PASSWD_PTR DW		;Pointeur dans PASSWD_GEN
PASSWD_DISP DS 8+1      ;Password  afficher, $FF
PASSWD_CURX DB          ;Curseur alphabet X
PASSWD_CURY DB          ;Curseur alphabet Y
PASSWD_CUR DB           ;Pointeur alphabet

DOGANIM DB		;Compteur animation pour le chien do not want

;Trucs en rapport avec le top-down engine, pas utilise finalement :(
;CAMERA_X DB             ;Coordonnes du coin haut gauche sur la map
;CAMERA_Y DB
;SCROLLING DB            ;Dcompte de $F  0
;PLAYER_X DB             ;Position en pixels du sprite du joueur (steps de 16)
;PLAYER_Y DB             ;Position en pixels du sprite du joueur (steps de 16)
;DIRECTION DB            ;Bit7 = Type de scroll (0:BG, 1:SPR), voir la table Directions
;CHARFRAME DB            ;N frame du walkcycle joueur *4

MAP_W DB
MAP_FIRST DB

WINDOW_Y DB

;Gamekim
HAND_X DB               ;Position
HAND_I DB               ;Inertie
CLENCH DB               ;Compteur main fermee/ouverte
SCORE DW                ;Score instantane en DCB 0~9999
TOADD DB                ;Score a ajouter
LIVES DB		;Nombre de poisons restants
FOODSPEED DB		;Vitesse de la bouffe en pixels/frame
SPEEDACC DB		;Accumulateur pour generer la vitesse de la bouffe, partage
FOODLIST   INSTANCEOF FOOD 5
POISONNB DB		;Nombre de poisons a l'ecran
INVINC DB		;Compteur d'invincibilite temporaire

;Gameroad
ROADSPEED DB		;Vitesse scroll route (ajoute a SPEEDACC, inc STRIPE sur overflow)
STRIPE DB               ;Numero du stripe a afficher
ROAD_X DB               ;Courbe du virage (7F = tout droit)
ROAD_GOAL DB
ROAD_GOAL_DELTA	DW	;07F~37F
APPEAR_DELTA DB		;Temps avant qu'un nouvel objet apparaisse
CAR_X DB                ;7 7.3 fixed point
CAR_X_LOW DB            ;3, bit 7 = drifting
CAR_PUSH DB		;Depend du virage (decalage voiture)
DRIFTING DB		;!=0 si on derape (anim voiture + son)
ANIMAL_TYPE DB		;Bit 7 = BAM DANS LA GUEULE
ANIMAL_X DB		;Depend du virage
ANIMAL_XVIS DB		;X sur a route quand il se rapproche (Xfinal = RoadX+(Y*XVIS), un truc du genre)
ANIMAL_X_THROW DB	;Vitesse de jartage (en fonction de l'endroit d'impact sur la voiture)
ANIMAL_Y DB		;5.3 fixed point A remapper sur perspective
ANIMAL_Y_THROW DB	;Vitesse Y quand ca jarte
PALACC DB		;Accumulateur alternance palette pour bords de route
PALSPEED DB		;Valeur a ajouter a PALACC pour rendre la perspective (decrementation chaque ligne)
SLOWACC DB

;Gamecamp
TRACKSTATE DB		;Bits 2/1/0 = aiguillages droite,milieu,gauche
TRACK_CUR DB		;0~2 aiguillages gauche, milieu, droite
WAGONLIST INSTANCEOF WAGON 12
TIMER_TRAIN DB		;Timer pour l'envoi des trains
TIMER_LAUNCH DB		;Frames a attendre entre l'envoi de chaque wagon d'un train
TOLAUNCH DB		;Nombre de wagons a balancer encore
NEXT_TYPE DB		;Code du prochain train
CAMP1_TYPE DB           ;Type de chaque camp (0~3)
CAMP2_TYPE DB
CAMP3_TYPE DB
CAMP4_TYPE DB
PAUSESND DB             ;Pseudo hack pour lire correctement le jingle pause pendant qu'un train roule

;Scroll (credits, intros...)
Scroll_Fade_End DB
Scroll_TxtPtr DW       	;Pointeur vers le texte
Scroll_MapPtr DW       	;Pointeur vers la map BG
Scroll_JumpTo DW	;Pointeur vers ou sauter a la fin du texte

;Timer
TIME_FRAME DB
TIME_SEC DB
TIME_MIN DB

;Sotplayer stuff
Sot_Music DW         ;Word, ptr to music table data
Sot_Speed DB         ;Byte
Sot_FrameC DB	     ;Byte, Internal frame counter
Sot_Flags DB         ;Byte, Internal and user flags
Sot_ActiveCH DB	     ;Byte, Active channels for song (bits 3~0)
Sot_Delta_1 DW       ;Word, Delta for CH1
Sot_Delta_2 DW       ;Word, ...
Sot_Delta_3 DW       ;Word
Sot_Delta_4 DW       ;Word
Sot_Ptr_1 DW         ;Word, Absolute ptr to next note CH1
Sot_Ptr_2 DW         ;Word
Sot_Ptr_3 DW         ;Word
Sot_Ptr_4 DW         ;Word
Sot_Ins_1 DB         ;Byte, Last played instrument
Sot_Ins_2 DB         ;Byte...
Sot_Ins_3 DB
Sot_Ins_4 DB

.ENDE

.DEFINE OAMCOPY $DF00           ;$DF00~$DF9F pour copie DMA vers OAM
.DEFINE ROAD_OFFSETS $DE00      ;Buffer d'offsets et palette pour chaque ligne horizontale de la route

.DEFINE VERBOSE 0		;Debug

;Sot flag defs, Internal
.DEFINE   Sot_F_EOS	 $10    ;Atteint la fin de la zic ?
;User
.DEFINE   Sot_F_Loop	 $01    ;Boucler
.DEFINE	  Sot_F_Play	 $02    ;Lire
.DEFINE   Sot_F_Turnoff  $04	;Couper le circuit son apres avoir fini de lire (jingle pause)

.ORG $0000                      ;A=(HL+A) LUT
  push   de
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  pop    de
  ret

.org $0010                      ;(HL)=DE
  ld     (hl),d
  inc    hl
  ld     (hl),e
  ret

.org $0020                      ;CALL (HL) si (HL) != 0
  ldi    a,(hl)
  ld     h,(hl)
  ld     l,a
  or     h
  call   nz,dojump
  ret

;Quelques routines random pour profiter de l'espace dispo jusque $100

dec_invinc:
  ld     a,(INVINC)
  or     a
  ret    z
  dec    a
  ld     (INVINC),a
  ret

mul6:
  ld     b,a     		;*4+*2
  add    a
  add    a
  add    b
  add    b
  ret

.ORG $0040
jp      VBlank

.ORG $0048
jp      RLI
.dw     $6A2B			;Bullshit inutile :)
checksum:                   	;Checksum (@ $004D)
.dw     0

sh_incscore:
  ld     a,(TOADD)
  dec    a
  ld     (TOADD),a
  call   inc_score
  ld     hl,fxscore
  call   playsfx
  ret

bin2bcd:			;Convertis A en BCD
  push	 bc
  ld	 b,10
  ld	 c,-1
div10:
  inc	 c
  sub	 b
  jr	 nc,div10
  add	 b
  ld	 b,a
  ld 	 a,c
  add	 a
  add	 a
  add	 a
  add	 a
  or	 b
  pop	 bc
  ret

clear:				;Fout  zro HL -> HL+BC
  xor    a
  ldi    (hl),a
  dec    bc
  ld     a,c
  or     b
  jr     nz,clear
  ret

setgame:
  ld     a,(GAME_FLAGS)		;Conserve flag nouvelle partie/from password
  and    $80
  or     b                      ;B = # du jeu
  ld     (GAME_FLAGS),a
  ret
  
load_RLI:			;Charge la routine RLI depuis DE
  ld     hl,RLI+1
  ld     (hl),e
  inc    hl
  ld     (hl),d
  ret
  
get_random:			;Comme son nom l'indique, resultat dans RAND8
  push  bc
  ld    a,(RAND8)
  ld    b,a
  rrca
  rrca
  rrca
  xor   $1F
  add   b
  sbc   255
  ld    (RAND8),a
  pop   bc
  ret

;Input: H = Multiplier, E = Multiplicand
;Output: HL = Product
;Routine repiquee de Z80 Bits (merci !)
mul8_8:
  ld    l,0
  ld    d,0

  sla	h		;optimised 1st iteration
  jr	nc,+
  ld	l,e
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  add	hl,hl		;unroll 7 times
  jr	nc,+		;...
  add	hl,de		;...
+:
  ret

screen_off:               	;teins l'cran dans le vblank
  call   wait_vbl
  ld     a,%00010001
  ldh    ($40),a
  ret

disp_score:
  ld     a,(SCORE)
  ld     d,a
  ld     a,(SCORE+1)
  ld     e,a
  ld     hl,$9800+1
  call   disp_DE_big
  ret
  
pause_sound:			;Joue le jingle de pause (non, ne met pas en pause la musique)
  ld     de,music_pause
  ld     hl,Sot_Music
  rst    $10
  call   setupmusic
  ret

.ORG $0100
nop
jp      start                   ;Entry point

.ORG $0104
;Logo Nintendo
.db $CE,$ED,$66,$66,$CC,$0D,$00,$0B,$03,$73,$00,$83,$00,$0C
.db $00,$0D,$00,$08,$11,$1F,$88,$89,$00,$0E,$DC,$CC,$6E,$E6
.db $DD,$DD,$D9,$99,$BB,$BB,$67,$63,$6E,$0E,$EC,$CC,$DD,$DC
.db $99,$9F,$BB,$B9,$33,$3E

.org $014A
.db 1				;Non-Japanese

.org $0150

start:
  ;A=11,B=00: CGB
  ;A=11,B=01: GBA
  ;A=?, B=?:  GBP
  ;A=1, B=00: SGB/DMG ?

  di

  ld     sp,$FFF4               ;Dbut du stack en HRAM @ $FFF4

  xor    a
  ldh    ($26),a                ;Coupe le circuit son

  ld     hl,$C000		;Vide la RAM
  ld     bc,$1FFF
  call   clear

  ld     a,$C3
  ld     (RLI),a		;Mise en place du JP en RAM pour la RLI

  call   sumcheck               ;Vrif checksum des 32ko

  call   emucheck
  ld     a,(ISEMULATOR)
  or     a
  call   nz,setup_lock

  call   printshit      	;Easter egg GB printer

  call   readinput
  cp     $04			;Select
  call   z,disp_serial

  call   Setup_logo

loop:
  jr     loop

  .INCLUDE "system.asm"         ;Readinput (avant y'en avait +, mais ca a fini ici dans main.asm)
  .INCLUDE "interrupts.asm"     ;Gestion VBlank, RLI = juste un JP+JP en RAM
  .INCLUDE "gfxutil.asm"        ;Magie video, passe son temps a attendre que la VRAM soit prete
  .INCLUDE "text.asm"           ;Strings, intro, credits, bios...
  ;.INCLUDE "cartswap.asm"
  .INCLUDE "printer.asm"        ;Easter egg GB printer
serial_ptr:
  .INCBIN "serial.bin"		;Au milieu de rien :)
  .INCLUDE "emucheck.asm"       ;Detection d'emulateur
  .INCLUDE "sumcheck.asm"       ;Checksummeur
  .INCLUDE "lock.asm"           ;Bloquage en cas de fail sur les tests au boot
  .INCLUDE "logo.asm"           ;Ecran logo FSE
  .INCLUDE "title.asm"          ;Ecran titre + menu
  .INCLUDE "password.asm"       ;Ecran d'entree de pass
  .INCLUDE "serial.asm"         ;Ecran affichage serial (SELECT au boot)
  .INCLUDE "intro.asm"          ;Scroller d'intro
  .INCLUDE "gameover.asm"       ;Ecran de game over
  .INCLUDE "credits.asm"        ;Scroller credits
  ;.INCLUDE "tilengine.asm"
  .INCLUDE "gamekim_setup.asm"  ;Init gamekim
  .INCLUDE "gameroad_setup.asm" ;Pareil pour gameroad
  .INCLUDE "gamecamp_setup.asm" ;...
  .INCLUDE "world_setup.asm"    ;Init carte du monde
  .INCLUDE "sfx.asm"            ;Def des effets sonores (config instruments)
  .INCLUDE "sotplayer.asm"      ;Bleep bleep
  .INCLUDE "scroller.asm"       ;Partage puisque utilise souvent
  .INCLUDE "fader.asm"          ;Pareil, fadeto, fadefrom, etc...
  .INCLUDE "introkim.asm"       ;Scroller bio pour gamekim + scoreboard
  .INCLUDE "introroad.asm"      ;Pareil pour gameroad
  .INCLUDE "introcamp.asm"	;...
  .INCLUDE "shared.asm"         ;Trucs de gameplay communs genre vies, score, temps...
  .INCLUDE "pass_util.asm"      ;Gene et verif de pass
  .INCLUDE "batard.asm"         ;Ecran mode batard (Konami code)

  .INCLUDE "music/m_intro.asm"  ;Zic intro
  .INCLUDE "music/m_pause.asm"  ;Jingle pause
  .INCLUDE "music/m_win.asm"    ;Jingle score 9999
  .INCLUDE "music/m_lose.asm"   ;Jingle perdu
  .INCLUDE "music/m_fx_train.asm"   ;Son des trains

  .INCLUDE "introtext0.asm"

.BANK 1 SLOT 0
.ORG $0000

  ;.INCLUDE "macroblocs.inc"
  .INCLUDE "gfx.asm"            ;Tas de pixels et de maps
  .INCLUDE "cosine.asm"         ;Table de cos
  .INCLUDE "introtext1.asm"

  ; Bite.
  