; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

  .INCLUDE "password_input.asm"
  .INCLUDE "password_vbl.asm"

Setup_passwd:
  di

  call   wait_vbl

  ld     a,%00010001            ;Turn off screen
  ldh    ($40),a

  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto
  
  ld     hl,(:tiles_motdepasse*$4000)+tiles_motdepasse
  ld     de,$8000+(104*16)
  call   loadtiles_auto

  ld     hl,(:tile_cur*$4000)+tile_cur
  ld     de,$8000+($98*16)
  call   loadtiles_auto
  
  ld     hl,(:tiles_nopedog*$4000)+tiles_nopedog
  ld     de,$8000+($99*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  ld     hl,OAMCOPY
  ld     bc,$A0
  call   clear

  ;map banner
  ld     a,104
  ld     de,$9800+(32*2)+2
  ld     hl,(:map_motdepasse*$4000)+map_motdepasse
  call   map

  ld     hl,$9800+(32*10)+4
  ld     b,12
  ld     de,keyboard
  call   maptextlimit
  
  ld     hl,$9800+(6*32)+5
  ld     a,'['-32
  ld     (hl),a
  ld     hl,$9800+(6*32)+6+8
  ld     a,']'-32
  ld     (hl),a

  ld     de,OAMCOPY
  ld     hl,map_cursor
  ld     b,4
-:
  ldi    a,(hl)                 ;Y
  ld     (de),a
  inc    e
  ldi    a,(hl)                 ;X
  ld     (de),a
  inc    e
  ldi    a,(hl)                 ;Tile
  ld     (de),a
  inc    e
  ldi    a,(hl)                 ;Attributes
  ld     (de),a
  inc    e
  dec    b
  jr     nz,-
  
  xor    a
  ld     (PASSWD_CURX),a
  ld     (PASSWD_CURY),a
  ld     (PASSWD_CUR),a
  ld     (FADEIDX),a
  ld     (DOGANIM),a

  call   pass_clear

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X
  ld     a,4 ;-4
  ldh    ($4B),a		;Window X
  ld     a,144
  ldh    ($4A),a                ;Window Y

  ld     a,%11100100            ;BG palette
  ldh    ($47),a
  ld     a,%11100100            ;SPR0 palette
  ldh    ($48),a
  ld     a,%11110011            ;Turn on screen, BG on, sprites ON 8x8, window OFF, tiles at $8000
  ldh    ($40),a
  ld     a,%00010000            ;Vblank only
  ldh    ($41),a
  ld     a,%00000001
  ldh    ($FF),a

  ld     hl,VBL_HANDLER
  ld     de,VBL_passwd
  ld     (hl),e
  inc    hl
  ld     (hl),d
  
  call   startsfx
  
  xor    a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei

  ret


pass_clear:
  ld     hl,PASSWD_DISP         ;Erase the displayed pass buffer
  ld     b,8+1
  ld     a,$FF
-:
  ldi    (hl),a
  dec    b
  jr     nz,-
  ret

  
pass_disp:
  ld     hl,$9800+(6*32)+6
  ld     de,pass_erase
  ld     b,32
  call   maptext                ;Erase with blank characters
  ld     hl,$9800+(6*32)+6
  ld     de,PASSWD_DISP
  ld     b,32
  call   maptext                ;Update displayed pass
  ret
 

passwd_getlimitx:
  ld     a,(PASSWD_CURY)        ;Get X limit of cursor for the current line
  ld     hl,limits
  ld     d,0
  ld     e,a
  add    hl,de
  ld     b,(hl)                 ; B=(limits + Y)
  ret

exit_passwd:
  ld     de,Setup_title
  call   Setup_exit_white
  ret

val_passwd:
  call   check_passwd
  dec    a
  ret    z
  ;bad pass
  dec    a
  jr     z,+
  ;map the doggie on the window
  ld     a,$99
  ld     de,$9C25
  ld     hl,(:map_nopedog*$4000)+map_nopedog
  call   map
  jr     ++
+:
  ;map the text on the window
  ld     de,text_nolife
  ld     hl,$9C83
  ld     b,32
  call   maptext
++:
  ld     de,music_lose
  ld     hl,Sot_Music
  rst    $10
  call   setupmusic
  ld     a,Sot_F_Play
  ld     (Sot_Flags),a
  ld     a,$FF
  ld     (DOGANIM),a
  ret

keyboard:
.db "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789            VALIDER MENU",$FF

pass_erase:
.db "        ",$FF

limits:
.db 11,11,11,1

x_special:
.db 0,8

passwd_jumps:
.dw val_passwd,exit_passwd

map_cursor:
.db 0,0,$98,%00000000 ;Y,X,Tile,Attributes (flip)
.db 0,0,$98,%00100000
.db 0,0,$98,%01000000
.db 0,0,$98,%01100000
