; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

password_input:
  call   readinput

  ld     a,(JOYP_ACTIVE)
  bit    0,a
  jr     z,+++                  ;A button
  ld     a,(PASSWD_CURY)	;0,1,2: character lines
  cp     3
  jr     c,+
;On the last line (3)
  ld     a,(PASSWD_CURX)        ;Jump to (passdw_jumps+CURX*2)
  sla    a
  ld     d,0
  ld     e,a
  ld     hl,passwd_jumps
  add    hl,de
  ld     e,(hl)
  inc    hl
  ld     d,(hl)
  push   de
  ret                           ;JP DE
+:
;On character lines (0,1,2)
  ld     a,(PASSWD_CUR)
  cp     8                      ;Password filled ?
  jr     z,++                   ;Ignore
  ld     e,a
  push   de                     ;Push pass cursor's position (E)
  ld     a,(PASSWD_CURY)        ;A=12*CURY
  or     a
  jr     z,+                    ;Skip multiplyu if = 0
  ld     b,a
  xor    a
-:
  add    12
  dec    b
  jr     nz,-
+:
  ld     hl,PASSWD_CURX
  add    (hl)                   ;A=A+CURX
  ld     l,a
  ld     h,0
  ld     de,keyboard
  add    hl,de
  ld     a,(hl)                 ;A=Keyboard((12*CURY)+CURX)
  ld     hl,PASSWD_DISP
  pop    de                     ;Gets E back
  ld     d,0
  add    hl,de
  ld     (hl),a                 ;Writes character
  call   pass_disp
  ld     hl,PASSWD_CUR
  inc    (hl)
  ld     hl,fx_val
  call   playsfx
  jr     +++
++:
  ld     hl,fx_err
  call   playsfx
+++:

  ld     a,(JOYP_ACTIVE)
  bit    1,a
  jr     z,++                   ;B button
  ld     hl,fx_err
  call   playsfx
  ld     a,(PASSWD_CUR)
  or     a                      ;Empty password ?
  jr     z,++                   ;Ignore
  ld     a,(PASSWD_CUR)
  dec    a
  ld     (PASSWD_CUR),a
  ld     e,a
  ld     d,0
  ld     hl,PASSWD_DISP
  add    hl,de
  ld     a,$FF
  ld     (hl),a
  call   pass_disp
++:

  ld     a,(JOYP_ACTIVE)
  bit    4,a                    ;Right
  jr     z,+++
  call   passwd_getlimitx
  ld     a,(PASSWD_CURX)
  cp     b
  jr     nz,+
  xor    a                      ;Wrap
  jr     ++
+:
  inc    a
++:
  ld     (PASSWD_CURX),a
  ld     hl,fxscore		;Selection beep
  call   playsfx
+++:

  ld     a,(JOYP_ACTIVE)
  bit    5,a                    ;Left
  jr     z,+++
  ld     a,(PASSWD_CURX)
  or     a
  jr     nz,+
  call   passwd_getlimitx       ;Wrap
  dec    a
  ld     a,b
  jr     ++
+:
  dec    a
++:
  ld     (PASSWD_CURX),a
  ld     hl,fxscore		;Selection beep
  call   playsfx
+++:

  ld     a,(JOYP_ACTIVE)
  bit    7,a                    ;Down
  jr     z,+
  ld     a,(PASSWD_CURY)
  cp     3
  jr     z,+
  inc    a
  ld     (PASSWD_CURY),a
  ld     hl,fxscore		;Selection beep
  call   playsfx
+:

  ld     a,(JOYP_ACTIVE)
  bit    6,a                    ;Up
  jr     z,+
  ld     a,(PASSWD_CURY)
  or     a
  jr     z,+
  dec    a
  ld     (PASSWD_CURY),a
  ld     hl,fxscore		;Selection beep
  call   playsfx
+:
  ret
