; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

VBL_passwd:
  call   fadefromwhite
  call   RAMtoOAM
  call   pass_doganim
  ld     a,(DOGANIM)
  or     a
  jr     nz,+
  call   password_input
+:
  call   pass_updatecur
  call   pass_rendercur
  call   stepmusic		; For the bad password jingle
  ret
  
  
pass_doganim:
  ld     a,(DOGANIM)
  or     a
  ret    z
  cp     $D8
  jr     c,+
  ldh    a,($4A)
  dec    a
  dec    a
  ldh    ($4A),a                ;Window Y
  jr     ++
+:
  cp     $A0
  jr     nc,++
  cp     $70
  jr     nc,+
  call   pass_clear
  call   pass_disp
  xor    a
  ld     (DOGANIM),a
  ld     (PASSWD_CUR),a
  ld     a,144
  ldh    ($4A),a                ;Window Y
  ret
+:
  ldh    a,($4A)
  inc    a
  inc    a
  ldh    ($4A),a                ;Window Y
++:
  ld     hl,DOGANIM
  dec    (hl)
  ret


pass_rendercur:
;----------------------------------------------------------------
;OAM buffer update (cursor)

  ld     hl,OAMCOPY

  ld     a,d            ;Sprite 0 (top left)
  ldi    (hl),a         ;Y
  ld     a,e
  ldi    (hl),a         ;X

  add    8              ;X+8
  ld     e,a
  inc    hl
  inc    hl

  ld     a,d            ;Sprite 1 (top right)
  ldi    (hl),a
  add    8              ;Y+8
  ld     d,a
  ld     a,e
  ldi    (hl),a
  sub    8              ;X-8
  ld     e,a
  inc    hl
  inc    hl

  ld     a,d            ;Sprite 2 (bottom left)
  ldi    (hl),a
  ld     a,e
  ldi    (hl),a
  add    8              ;X+8
  ld     e,a
  inc    hl
  inc    hl

  ld     a,d            ;Sprite 3 (bottom right)
  ldi    (hl),a
  ld     a,e
  ld     (hl),a

  ld     hl,VBLC
  inc    (hl)
  ret

  
pass_updatecur:
;----------------------------------------------------------------
;Make the cursor's position, puts XY in DE

  ld     a,(DOGANIM)
  or     a
  jr     z,+
  ld     de,$E0E0
  ret

+:
  ld     a,(PASSWD_CURY)
  sla    a
  sla    a
  sla    a                      ;*8+91 for Y
  add    91
  ld     d,a

  ld     a,(PASSWD_CURY)
  cp     3                      ;Special case for X when we're on the last line (menu)
  ld     a,(PASSWD_CURX)
  jr     nz,++
  cp     2
  jr     c,+
  xor    a                      ;Resets X to 0 if we're out of bounds (2)
  ld     (PASSWD_CURX),a
+:
  push   de
  ld     hl,x_special           ;LUT for the X on the last line
  ld     d,0
  ld     e,a
  add    hl,de
  ld     a,(hl)
  pop    de
  push   af
  ;Offsets Y for the last line (line feed)
  ld     a,d
  add    8
  ld     d,a
  pop    af
++:
  sla    a
  sla    a
  sla    a                      ;*8+36 for X
  add    36
  ld     e,a
  ret

