; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

printshit:
  di
  call	 screen_off

  ;Load alphabet in VRAM, just to decompress
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ld     hl,printer_init
  call   serialstream
  ld     a,d                    ;D=answer
  inc    a                      ;=$FF ?
  ret    z                      ;No printer there, do nothing else

  ld     a,$88
  call   serialput
  ld     a,$33
  call   serialput		;Magic bytes
  ld     a,$04
  call   serialput              ;Transfer picture command
  xor    a
  call   serialput              ;No compression
  ld     a,$80
  call   serialput              ;$280 bytes of data (160*16/4)
  ld     a,$02
  call   serialput

  ld     hl,$0086		;Init checksum ($04+$80+$02)
  ld     bc,$0280
  ld     bc,bush_quote
-:
  ld     a,(bc)
  cp     $FF
  jr     z,+
  inc    bc
  sub    32
  push   hl			;Calculate needed tile's address
  sla    a			;*2
  ld     h,0
  ld     l,a
  add    hl,hl
  add    hl,hl
  add    hl,hl			;*16
  ld     de,$8000
  add    hl,de
  push   hl
  pop    de			;DE=HL
  pop    hl
--:
  ld     a,(de)
  push   de
  ld     d,0
  ld     e,a
  add    hl,de			;Add to checksum
  pop    de
  call   serialput              ;Sends the stuff to the printer
  inc    de
  ld     a,e
  and    $F
  jr     nz,--
  jr     -
+:

  ld     a,l
  call   serialput              ;Serial LSB
  ld     a,h
  call   serialput              ;Serial MSB
  xor    a
  call   serialput
  xor    a
  call   serialput
  ldh    a,($01)		;Did the printer say the checksum is good ?
  and    1
  or     a
  ret    nz                     ;No: we fucked up, abandon ship !

  call   startsfx
  ld     hl,fx_grabok		;To tell the player something special is about to happen
  call   playsfx

  ld     hl,printer_dataend
  call   serialstream

  ld     hl,printer_print
  call   serialstream
  ret

serialstream:
  ldi    a,(hl)
  cp     $FF
  jr     nz,+
  xor    a                      ;End of stream, ask for a reply
  call   serialput
  ld     a,($FF01)
  ld     d,a                    ;Save to D (BC trashed by nopwait)
  xor    a                      ;Ask for status
  call   serialput
  jr     printerwait
+:
  call   serialput
  jr     serialstream

printer_init:
.db $88,$33,$01,$00,$00,$00,$01,$00,$FF	;Init sequence
printer_dataend:
.db $88,$33,$04,$00,$00,$00,$04,$00,$FF ;Empty data sequence
printer_print:
.db $88,$33,$02,$00,$04,$00,$01,$13,$E4,$40,$3E,$01,$FF	;Print params

bush_quote:
.db "        THEY        "
.db "MISUNDERESTIMATED ME",$FF

serialput:
  push   bc
  ld     ($FF01),a
  ld     a,$81
  ld     ($FF02),a
  ld     b,$FF
-:
  dec    b
  jr     nz,-
  pop    bc
  ret
  
printerwait:
  ld     bc,$1FF
-:
  dec    bc
  ld     a,b
  or     c
  jr     nz,-
  ret
