; Sotplayer V1.2 for WLA-DX GBZ80
; CC furrtek 2012 - Use and redistribute as is
; Furrtek.org

; Procedure:	Param:
; setupmusic    Sot_Music:Pointer to music table, flags/config + 4 pointers (data for each channel)
; stepmusic	Nope, needs to be called each frame
; stopmusic	Nope
setupmusic:
  ld     a,%10000000
  ldh    ($26),a        ; Sound on
  
  xor    a
  ld     (Sot_FrameC),a

  ; Init deltas and step pointers for each channel
  ld     hl,Sot_Music
  ldi    a,(hl)		; DE = pointer to music data
  ld     d,a
  ld     e,(hl)
  push   de		; HL=DE
  pop    hl

  ldi    a,(hl)		; Active channels for song
  ld     (Sot_ActiveCH),a
  ldi    a,(hl)         ; Speed (step each x frames)
  ld     (Sot_Speed),a
  ldi    a,(hl)
  ldh    ($25),a        ; Channels panning

  ldi    a,(hl)		; DE = pointer to channel data ptr table
  ld     e,a
  ld     d,(hl)
  inc    hl

  push   hl             ; Save ptr for CH2 data ptr
  push   de             ; HL=DE
  pop    hl
  call   getdelta
  push   hl             ; Save HL for step pointer
  ld     hl,Sot_Delta_1
  call   storeDEHL      ; Init delta
  pop    de
  ld     hl,Sot_Ptr_1   ; Init step pointer
  call   storeDEHL
  pop    hl		; Get back ptr for CH2

  ldi    a,(hl)         ; Exactly the same thing x4 :)
  ld     e,a
  ld     d,(hl)
  inc    hl
  push   hl
  push   de
  pop    hl
  call   getdelta
  push   hl
  ld     hl,Sot_Delta_2
  call   storeDEHL
  pop    de
  ld     hl,Sot_Ptr_2
  call   storeDEHL
  pop    hl

  ldi    a,(hl)
  ld     e,a
  ld     d,(hl)
  inc    hl
  push   hl
  push   de
  pop    hl
  call   getdelta
  push   hl
  ld     hl,Sot_Delta_3
  call   storeDEHL
  pop    de
  ld     hl,Sot_Ptr_3
  call   storeDEHL
  pop    hl

  ldi    a,(hl)
  ld     e,a
  ld     d,(hl)
  inc    hl
  push   hl
  push   de
  pop    hl
  call   getdelta
  push   hl
  ld     hl,Sot_Delta_4
  call   storeDEHL
  pop    de
  ld     hl,Sot_Ptr_4
  call   storeDEHL
  pop    hl

  ld     a,%01110111            ; No Vin, Left and Right at max volume
  ldh    ($24),a

  ld     a,(Sot_Flags)
  and    $0F
  ld     (Sot_Flags),a		; Not at End Of Song

  ret

storeDEHL:
  ld     a,d
  ldi    (hl),a
  ld     (hl),e
  ret

getdelta:
  ld     d,0                    ; Get new delta (1 to 2 bytes) in DE from HL
  ldi    a,(hl)
  bit    7,a                    ; >$7F flag ?, read LSB
  jr     z,+
  and    $7F
  ld     d,a
  ldi    a,(hl)
+:
  ld     e,a
  ret


stepmusic:
  ld     a,(Sot_Flags)		; Yup
  and    Sot_F_Play
  ret    z

  ld     a,(Sot_Speed)
  ld     b,a
  ld     hl,Sot_FrameC
  inc    (hl)
  ld     a,(hl)
  cp     b
  jr     nz,+			; Skip stepping if Sot_FrameC != Sot_Speed
  xor    a
  ld     (hl),a

  ld     b,0
  ld     a,(Sot_ActiveCH)
  bit    0,a
  call   nz,Do_T
  ld     b,1
  ld     a,(Sot_ActiveCH)
  bit    1,a
  call   nz,Do_T
  ld     b,2
  ld     a,(Sot_ActiveCH)
  bit    2,a
  call   nz,Do_T
  ld     b,3
  ld     a,(Sot_ActiveCH)
  bit    3,a
  call   nz,Do_T

  ld     a,(Sot_Flags)
  and    Sot_F_EOS
  jr     z,+			; Did we get EOS flag from a channel ?
  ld     a,(Sot_Flags)		; Yup
  and    Sot_F_Loop
  jr     z,stopmusic
  call   setupmusic             ; Loop if Sot_F_Loop flag is set
+:
  ret
  
  
waitforsongend:
-:
  ld     a,(Sot_Flags)		; Attend que le jingle soit lu
  and    Sot_F_Play
  jr     nz,-
  ret

stopmusic:
  ld     a,(Sot_Flags)		; Set x,(hl) might be better ?
  bit    1,a
  ret    z			; Deja off 
  bit    2,a
  jr     z,+                    ; Sot_F_Turnoff flag ?
  xor    a
  ldh    ($26),a                ; Disable APU
+:
  and    255~Sot_F_Play
  ld     (Sot_Flags),a
  ld     b,3
-
  call   SilenceChannel
  dec    b
  jr     nz,-
  ret

Do_T:
  ld     hl,Sot_Delta_1         ; Get Delta counter
  call   makeptr
  ldi    a,(hl)                 ; =0? 16bits
  or     (hl)
  jr     nz,+++                 ; Skip CH update if Delta > 0 (still have to wait)

nulldelta:

  ld     hl,Sot_Ptr_1           ; Make step pointer address
  call   makeptr

  push   hl                     ; DE=HL
  pop    de

  push   de                     ; 02 Save step pointer address

  ld     a,(de)                 ; HL=(DE) Get step pointer
  inc    de
  ld     h,a
  ld     a,(de)
  ld     l,a

  ldi    a,(hl)                 ; First byte

  bit    7,a                    ; Instrument change or note ?
  jr     z,+
  and    $7F                    ; Instrument change
  or     a
  jr     z,silence              ; Instrument 0 = note off
  cp     $7F                    ; Instrument = $7F: End Of Song
  jr	 nz,nEOS
  ld     a,(Sot_Flags)		; !!!! Set x,(hl) might be better ?
  or     Sot_F_EOS
  ld     (Sot_Flags),a
  pop    hl			; 02 Whatever, align stack
  ret
nEOS:
  push   hl			; 01 Save step pointer
  dec    a
  call   LoadInstrument		; Instrument > 0 = instrument change
  jr     doneli
silence:
  push   hl			; 01 Save step pointer
  call   SilenceChannel		; Silence: no note value, skip what follows
  pop    hl			; 01 Whatever, align stack
  jr     skipnote
doneli:
  pop    hl                     ; 01 Get back step pointer
  ldi    a,(hl)                 ; Note follows
+:
  and    $7F                    ; Note

  push   hl                     ; Save step ptr
  push   af                     ; Save note number

  ld     hl,Sot_Ins_1           ; Get channel number of last instrument played
  ld     d,0
  ld     e,b
  add    hl,de
  ld     a,(hl)			; A=(Sot_Ins_1+B)

  cp     3
  jr     nz,+
  pop    af                     ; Pop note number
  call   SetCH4                 ; Special case for CH4
  jr     ++
+:
  ld     c,a                    ; C = channel number
  pop    af                     ; Pop note number
  call   SetFreq                ; Use LUT to set frequency of CH1~3
++:

  pop    hl                     ; Pop track data ptr
skipnote:
  call   getdelta

  push   hl                     ; Save track data ptr
  push   de                     ; Save new Delta

  ld     hl,Sot_Delta_1
  call   makeptr

  pop    de                     ; Pop new Delta
  call   storeDEHL              ; Set new Delta

  pop    hl                     ; Pop track data ptr

  pop    de                     ; 02 Pop track pointer address
  ld     a,h                    ; (DE)=HL save new track pointer
  ld     (de),a
  inc    de
  ld     a,l
  ld     (de),a

+++:
  ld     hl,Sot_Delta_1         ; Dec delta counter if > 0
  call   makeptr
  ldi    a,(hl)                 ; =0? 16bits
  or     (hl)
  jr     z,nulldelta

  ld     e,(hl)                 ; (HL)-- 16bits
  inc    hl
  ld     d,(hl)
  dec    de
  ld     (hl),d
  dec    hl
  ld     (hl),e
  ret


makeptr:
  ld     d,0                    ; HL+=B*2
  ld     a,b
  add    a
  ld     e,a
  add    hl,de
  ret


SilenceChannel:                 ; B=Track #
  push   hl

  ld     hl,Sot_Ins_1           ; Get channel number of last instrument played
  ld     d,0
  ld     e,b
  add    hl,de
  ld     a,(hl)

  ld     hl,SilenceRegs         ; Volume registers
  ld     d,0
  ld     e,a
  add    hl,de
  ld     l,(hl)
  ld     h,$FF

  xor    a
  ld     (hl),a

  pop    hl

  ret

SilenceRegs:
  .db    $12
  .db    $17
  .db    $1A
  .db    $21


SetFreq:                        ; C=CH #   A=Note #
  push   hl
  push   bc

  ld     hl,notelut             ; Get address of note value in LUT (mettre plus bas ?)
  ld     d,0
  sub    32			; Optim zeros repetitifs
  add    a			; Words
  ld     e,a
  add    hl,de

  push   hl                     ; Save note LUT pointer

  ld     hl,freqregs            ; Get first frequency register number
  ld     d,0
  ld     e,c
  add    hl,de
  ld     c,(hl)
  ld     b,$FF                  ; BC = first register for frequency

  pop    hl                     ; Pop note LUT pointer

  ldi    a,(hl)
  ld     (bc),a                 ; LSB frequency
  inc    bc                     ; next register
  ld     a,(hl)
  or     $B0                    ; Set start sound bits
  ld     (bc),a                 ; MSB frequency

  pop    bc
  pop    hl

  ret

SetCH4:
  ld     a,$B0                  ; Just start sound, no frequency change
  ldh    ($23),a
  ret


LoadInstrument:                 ; A=instrument #
  ld     hl,instruments
  ld     d,0
  add    a
  ld     e,a
  add    hl,de         ; HL=(instruments+A*2)
  ldi    a,(hl)
  ld     h,(hl)
  ld     l,a           ; HL=(HL)
  or     h
  ret    z             ; Don't load if pointer = 0

  ldi    a,(hl)        ; Get channel number of instrument
  push   hl
  ld     hl,Sot_Ins_1   ; Save channel number in RAM (used for note update)
  ld     d,0
  ld     e,b
  add    hl,de
  ld     (hl),a        ; (Instru_1+B)=A

  ld     hl,LoadIJT    ; Jump table for instrument parameters loading routines
  ld     d,0
  add    a
  ld     e,a
  add    hl,de
  ldi    a,(hl)
  ld     h,(hl)
  ld     l,a

  jp     hl            ; JP (LoadIJT+A*2)

LoadIJT:
  .dw    loadCH1
  .dw    loadCH2
  .dw    loadCH3
  .dw    loadCH4

loadCH1:
  pop    hl
  ldi    a,(hl)
  ldh    ($10),a
  ldi    a,(hl)
  ldh    ($11),a
  ldi    a,(hl)
  ldh    ($12),a
  ld     a,(hl)
  ldh    ($14),a
  ret

loadCH2:
  pop    hl
  ldi    a,(hl)
  ldh    ($16),a
  ldi    a,(hl)
  ldh    ($17),a
  ld     a,(hl)
  ldh    ($19),a
  ret

loadCH3:
  pop    hl
  push   de
  ldi    a,(hl)
  ldh    ($1A),a
  ldi    a,(hl)
  ldh    ($1B),a
  ldi    a,(hl)
  ldh    ($1C),a
  ldi    a,(hl)
  ldh    ($1E),a
  ld     c,$10
  ld     de,$FF30                        ; Load wave RAM
-:
  ldi    a,(hl)
  ld     (de),a
  inc    de
  dec    c
  jr     nz,-
  pop    de
  ret

loadCH4:
  pop    hl
  ldi    a,(hl)
  ldh    ($20),a
  ldi    a,(hl)
  ldh    ($21),a
  ldi    a,(hl)
  ldh    ($22),a
  ld     a,(hl)
  ldh    ($23),a
  ret

freqregs:
  .db $13,$18,$1D
  
notelut:
  .include "notelut.asm"

