; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

sumcheck:
  ld     hl,$0150		;16bit add loop
  ld     bc,32768-$0150
  ld     de,0
-:
  ld     a,e
  add    (hl)
  ld     e,a
  jr     nc,+
  inc    d
+:
  inc    hl
  dec    bc
  ld     a,b
  or     c
  jr     nz,-
  
  ld     hl,checksum
  ldi    a,(hl)
  cp     e
  jp     nz,lock_checksum
  ld     a,(hl)
  jp     nz,lock_checksum
  ret
  
lock_checksum:
  call   wait_vbl
  xor    a                      ;Turn off screen
  ldh    ($40),a

  ;Charge l'alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites
  
  ld     de,text_sumerror
  ld     hl,$9800+(4*32)+3
  ld     b,32
  call   maptext

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11100100
  ldh    ($47),a

  ld     a,%10010001            ;Turn on screen, BG on, sprites OFF, window OFF, tiles at $8000
  ldh    ($40),a

-:
  halt
  nop
  jr     -

text_sumerror:
.db "Checksum error",$FF