.ROMDMG                         ; Pas de features CGB
.COMPUTEGBCHECKSUM              ; WLA-DX crira le checksum lui-mme (ncessaire sur une vraie GB)
.NAME "SOTPLAYER1 "             ; Nom du ROM inscrit dans le header
.EMPTYFILL $00                  ; Padding avec des 0
.CARTRIDGETYPE 0                ; ROM only
.LICENSEECODENEW "ED"           ; Code de license Nintendo
.COMPUTEGBCOMPLEMENTCHECK

.MEMORYMAP
SLOTSIZE $4000                  ; Deux banks de 16Ko
DEFAULTSLOT 0
SLOT 0 $0000
SLOT 1 $4000
.ENDME

.ROMBANKSIZE $4000
.ROMBANKS 2

.BANK 0 SLOT 0

.define   FLAGS          $C000
.define   VBLC           $C001       ; Byte, Compteur de frames en RAM

.define   Delta_1        $C002       ; Word
.define   Delta_2        $C004       ; Word
.define   Delta_3        $C006       ; Word
.define   Delta_4        $C008       ; Word

.define   STEPPTR_T1     $C010       ; Word
.define   STEPPTR_T2     $C012       ; Word
.define   STEPPTR_T3     $C014       ; Word
.define   STEPPTR_T4     $C016       ; Word

.define   Instru_1       $C020
.define   Instru_2       $C021
.define   Instru_3       $C022
.define   Instru_4       $C023

.define   VU1            $C024
.define   VU2            $C025
.define   VU3            $C026
.define   VU4            $C027

.define   SPEED          1

.include "header.s"

.org $0150
VBlank:
  push   af
  push   hl

  ld     a,(VU1)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU1),a

  ld     hl,$9800+32*6+2
  call   drawbar

  ld     a,(VU2)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU2),a

  ld     hl,$9800+32*8+2
  call   drawbar
  
  ld     a,(VU3)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU3),a

  ld     hl,$9800+32*10+2
  call   drawbar
  
  ld     a,(VU4)
  or     a
  jr     z,+
  dec    a
  dec    a
+:
  ld     (VU4),a

  ld     hl,$9800+32*12+2
  call   drawbar

  ld     b,$4F
-:
  dec    b
  jr     nz,-

  ld     a,%00011011            ; Pal BG
  ldh    ($47),a

  call   stepmusic

  ld     a,%11100100            ; Pal BG
  ldh    ($47),a

  pop    hl
  pop    af
  ret

start:
  di                            ; Interruption dsactives
  ld     sp,$fff4               ; Dbut du stack  $FFF4 parce que Nintendo le veut
  
  call   wait_vbl
  xor    a                      ; teins l'cran
  ldh    ($40),a

  ld     a,%00010000            ; VBL int
  ldh    ($41),a
  ld     a,%00000001            ; VBL int
  ldh    ($FF),a

  ld     hl,$C000
  ld     bc,$1FFF
-:
  xor    a
  ldi    (hl),a
  dec    bc
  ld     a,c
  or     b
  jr     nz,-

  ld     a,%11100100            ; Pal BG
  ldh    ($47),a

  ld     hl,music
  call   setupmusic
  
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_2BPPc

  ld     hl,(:tiles_logo*$4000)+tiles_logo
  ld     de,$8600
  call   loadtiles_2BPPc
  
  ld     hl,(:tiles_bar*$4000)+tiles_bar
  ld     de,$8740
  call   loadtiles_2BPPc

  ld     de,32*32               ;Vide la map BKG
  ld     hl,$9800
clmaplp:
  xor    a
  ldi    (hl),a
  dec    de
  ld     a,e
  or     d
  jr     nz,clmaplp

  ld     hl,$9800+32+5
  ld     a,$60
  ld     c,2
--:
  ld     b,10
-:
  ldi    (hl),a
  inc    a
  dec    b
  jr     nz,-
  ld     de,32-10
  add    hl,de
  dec    c
  jr     nz,--

  ld     hl,$9800+128+3
  ld     de,title
  call   write
  
  ld     hl,$9800+32*15+4
  ld     de,swag
  call   write

  ld     a,%10010001            ; Allume l'ecran
  ldh    ($40),a
  
  xor    a
  ldh    ($0F),a

  ei
lp:
  jr     lp
  
  
write:
-:
  ld     a,(de)
  or     a
  ret    z
  sub    32
  ldi    (hl),a
  inc    de
  jr     -

drawbar:
  call   wait_write
  ld    (hl),$74
  inc   hl
  ld     c,16
-:
  sub    8
  jr     nc,+
  xor    $FF
  ld     b,$76
  add    b
  call   wait_write
  ldi    (hl),a
  jr     ++
+:
  call   wait_write
  ld     (hl),$75
  inc    hl
  dec    c
  jr     -
++:
  ld     a,c
  or     a
  ret    z
  xor    a
-:
  call   wait_write
  ldi    (hl),a
  dec    c
  jr     nz,-
  ret
  
wait_write:
  push   af
-:
  ldh    a,($41)
  and    3
  cp     2
  jr     nc,-
  pop    af
  ret
  
.org $1000
  
  .include "sotplayer.s"
  .include "loadtile.asm"

title:
  .db "Dubmood - TDAY",$00
swag:
  .db "Furrtek 2012",$00

wait_vbl:
  ldh    a,($40)
  rlca
  jr     nc,dispoff
wait_vbll:
  ldh    a,($44)
  cp     144
  jr     nz,wait_vbll
dispoff:
  ret
  
tiles_alpha:
  .incbin "alphaftk.bin"
tiles_logo:
  .incbin "logo.bin"
tiles_bar:
  .incbin "bar.bin"

music:
  .dw track1
  .dw track2
  .dw track3
  .dw track4

track1:
  .incbin "tday_ch1.bin"
track2:
  .incbin "tday_ch2.bin"
track3:
  .incbin "tday_ch3.bin"
track4:
  .incbin "tday_ch4.bin"

notelut:
  .include "notelut.asm"

instruments:
  .dw instru1        ;Carre PWM 1 CH1
  .dw instru2        ;Carre PWM 2 CH1
  .dw instru3        ;Carre PWM 3 CH1
  .dw instru4        ;Carre PWM 4 CH1
  .dw instru5        ;Carre PWM 1 CH2
  .dw instru6        ;Carre PWM 2 CH2
  .dw instru7        ;Carre PWM 3 CH2
  .dw instru8        ;Carre PWM 4 CH2 sustain
  .dw instru9        ;Kick
  .dw instru10       ;Snare
  .dw instru11       ;Hat
  .dw instru12       ;Wave
  .dw instru12       ;Wave

instru1:
  .db 0
  .db $80
  .db $1F
  .db $B1
  .db $BF

instru2:
  .db 0
  .db $80
  .db $5F
  .db $B1
  .db $BF

instru3:
  .db 0
  .db $80
  .db $9F
  .db $B1
  .db $BF

instru4:
  .db 0
  .db $80
  .db $DF
  .db $B1
  .db $BF

instru5:
  .db 1
  .db $1F
  .db $83
  .db $BF

instru6:
  .db 1
  .db $5F
  .db $83
  .db $BF

instru7:
  .db 1
  .db $9F
  .db $83
  .db $BF

instru8:
  .db 1
  .db $DF
  .db $87
  .db $BF
  
instru9:
  .db 3
  .db $FF
  .db $B1
  .db $80
  .db $BF
  
instru10:
  .db 3
  .db $FF
  .db $81
  .db $51
  .db $BF

instru11:
  .db 3
  .db $FF
  .db $81
  .db $31
  .db $BF

instru12:
  .db 2
  .db $80
  .db $00
  .db $60
  .db $BF
  .db $FF
  .db $EE
  .db $DD
  .db $CC
  .db $BB
  .db $AA
  .db $99
  .db $88
  .db $77
  .db $66
  .db $55
  .db $44
  .db $33
  .db $22
  .db $11
  .db $00
