.ROMDMG                         ; Pas de features CGB
.COMPUTEGBCHECKSUM              ; WLA-DX crira le checksum lui-mme (ncessaire sur une vraie GB)
.NAME "SOTPLAYERSC"             ; Nom du ROM inscrit dans le header
.EMPTYFILL $00                  ; Padding avec des 0
.CARTRIDGETYPE 0                ; ROM only
.LICENSEECODENEW "ED"           ; Code de license Nintendo
.COMPUTEGBCOMPLEMENTCHECK

.MEMORYMAP
SLOTSIZE $4000                  ; Deux banks de 16Ko
DEFAULTSLOT 0
SLOT 0 $0000
SLOT 1 $4000
.ENDME

.ROMBANKSIZE $4000
.ROMBANKS 2

.BANK 0 SLOT 0

.ENUM $C000 EXPORT
; Application specific (not Sot)
FLAGS DB
VBLC DB
VU1 DB
VU2 DB
VU3 DB
VU4 DB

Sot_Music DW         ; Word, ptr to music table data
Sot_Speed DB         ; Byte
Sot_FrameC DB	     ; Byte, Internal frame counter
Sot_Flags DB         ; Byte, Internal and user flags
Sot_ActiveCH DB	     ; Byte, Active channels for song (bits 3~0)

Sot_Delta_1 DW       ; Word, Delta for CH1
Sot_Delta_2 DW       ; Word, ...
Sot_Delta_3 DW       ; Word
Sot_Delta_4 DW       ; Word

Sot_Ptr_1 DW         ; Word, Absolute ptr to next note CH1
Sot_Ptr_2 DW         ; Word
Sot_Ptr_3 DW         ; Word
Sot_Ptr_4 DW         ; Word

Sot_Ins_1 DB         ; Byte, Last played instrument
Sot_Ins_2 DB         ; Byte...
Sot_Ins_3 DB
Sot_Ins_4 DB

.ENDE


; Sot flag defs
.define   Sot_F_EOS	 $10
; User
.define   Sot_F_Loop	 $01
.define	  Sot_F_Play	 $02


.include "header.s"

.org $0150
VBlank:
  push   af
  push   hl

  call   drawVUs

  ld     a,%00011011            ; Pal BG inverted
  ldh    ($47),a

  call   stepmusic

  ld     a,%11100100            ; Pal BG normal
  ldh    ($47),a

  pop    hl
  pop    af
  ret

start:
  di                            ; Interruption dsactives
  ld     sp,$fff4               ; Dbut du stack  $FFF4 parce que Nintendo le veut

  call   wait_vbl
  xor    a                      ; teins l'cran
  ldh    ($40),a

  ld     a,%00010000            ; VBL int
  ldh    ($41),a
  ld     a,%00000001            ; VBL int
  ldh    ($FF),a

  ld     hl,$C000		; Clear RAM
  ld     bc,$1FFF
-:
  xor    a
  ldi    (hl),a
  dec    bc
  ld     a,c
  or     b
  jr     nz,-

  ld     a,%11100100            ; Pal BG
  ldh    ($47),a

  ld     de,music_intro
  ld     hl,Sot_Music
  ld     a,d   			; StoreDEHL
  ldi    (hl),a
  ld     (hl),e
  call   setupmusic

  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_2BPPc

  ld     hl,(:tiles_logo*$4000)+tiles_logo
  ld     de,$8600
  call   loadtiles_2BPPc

  ld     hl,(:tiles_bar*$4000)+tiles_bar
  ld     de,$8740
  call   loadtiles_2BPPc

  ld     de,32*32               ;Vide la map BKG
  ld     hl,$9800
clmaplp:
  xor    a
  ldi    (hl),a
  dec    de
  ld     a,e
  or     d
  jr     nz,clmaplp

  ld     hl,$9800+32+5
  ld     a,$60
  ld     c,2
--:
  ld     b,10
-:
  ldi    (hl),a
  inc    a
  dec    b
  jr     nz,-
  ld     de,32-10
  add    hl,de
  dec    c
  jr     nz,--

  ld     hl,$9800+128+3
  ld     de,title
  call   write
  
  ld     hl,$9800+32*15+4
  ld     de,swag
  call   write

  ld     a,%10010001            ; Allume l'ecran
  ldh    ($40),a
  
  xor    a
  ldh    ($0F),a 		; Interrupt flags

  ld     a,Sot_F_Play+Sot_F_Loop
  ld     (Sot_Flags),a

  ei
lp:
  jr     lp
  
  
write:
-:
  ld     a,(de)
  or     a
  ret    z
  sub    32
  ldi    (hl),a
  inc    de
  jr     -


.org $1000
  
  .include "sotplayer.s"
  .include "loadtile.asm"

title:
  .db "SupCon - Intro",$00
swag:
  .db "Furrtek 2013",$00

wait_vbl:
  ldh    a,($40)
  rlca
  jr     nc,dispoff
wait_vbll:
  ldh    a,($44)
  cp     144
  jr     nz,wait_vbll
dispoff:
  ret

  .include "vus.s"

tiles_alpha:
  .incbin "alphaftk.bin"
tiles_logo:
  .incbin "logo.bin"
tiles_bar:
  .incbin "bar.bin"

music_intro:
  .db %00001111	; Channels 4,3,2,1  00001011
  .db 1		; Speed
  .db $F 	; Panning
  .dw track1
  .dw track2
  .dw track3
  .dw track4

track1:
  .incbin "sc_intro_1.bin"
track2:
  .incbin "sc_intro_2.bin"
track3:
  .incbin "sc_intro_3.bin"
track4:
  .incbin "sc_intro_4.bin"

notelut:
  .include "notelut.asm"

instruments:
  .dw instru1        ;Carre PWM 1 CH1
  .dw instru2        ;Carre PWM 2 CH1
  .dw instru3        ;Carre PWM 3 CH1
  .dw instru4        ;Carre PWM 4 CH1
  .dw instru5        ;Carre PWM 1 CH2
  .dw instru6        ;Carre PWM 2 CH2
  .dw instru7        ;Carre PWM 3 CH2
  .dw instru8        ;Carre PWM 4 CH2 sustain
  .dw instru9        ;Kick
  .dw instru10       ;Snare
  .dw instru11       ;Hat
  .dw instru12       ;Wave
  .dw instru12       ;Wave

instru1:
  .db 0
  .db $80
  .db $1F
  .db $87
  .db $BF

instru2:
  .db 0
  .db $80
  .db $5F
  .db $B1
  .db $BF

instru3:
  .db 0
  .db $80
  .db $9F
  .db $B1
  .db $BF

instru4:
  .db 0
  .db $80
  .db $DF
  .db $B1
  .db $BF

instru5:
  .db 1
  .db $1F
  .db $83
  .db $BF

instru6:
  .db 1
  .db $5F
  .db $83
  .db $BF

instru7:
  .db 1
  .db $9F
  .db $83
  .db $BF

instru8:	;CH2
  .db 1
  .db $D1	;DF
  .db $F7	;87 envelope length+sweep time
  .db $BF

instru9:
  .db 3
  .db $FF
  .db $B1
  .db $80
  .db $BF

instru10:
  .db 3
  .db $FF
  .db $81
  .db $51
  .db $BF

instru11:
  .db 3
  .db $FF
  .db $81
  .db $31
  .db $BF

instru12:
  .db 2
  .db $80
  .db $00
  .db $40
  .db $BF
  .db $FF
  .db $EE
  .db $DD
  .db $CC
  .db $BB
  .db $AA
  .db $99
  .db $88
  .db $77
  .db $66
  .db $55
  .db $44
  .db $33
  .db $22
  .db $11
  .db $00
