; This file is part of the source code for "Super Connard" V1
; Creative Commons BY-NC-SA 2013 - furrtek.org

  .DEFINE TI_T_LOGO	96
  .DEFINE TI_T_FOOTER	$D2

Setup_title:
  di
  call	 screen_off

  ;Load alphabet
  ld     hl,(:tiles_alpha*$4000)+tiles_alpha
  ld     de,$8000
  call   loadtiles_auto

  ;Load logo
  ld     hl,(:tiles_logo*$4000)+tiles_logo
  ld     de,$8000+(TI_T_LOGO*16)
  call   loadtiles_auto
  
  ;Load the "FSE" footer
  ld     hl,(:tiles_footer*$4000)+tiles_footer
  ld     de,$8000+(TI_T_FOOTER*16)
  call   loadtiles_auto

  call   clearbkg
  call   clearsprites

  ;Map the logo
  ld     a,TI_T_LOGO
  ld     de,$9800+(32*2)+2
  ld     hl,(:map_logo*$4000)+map_logo
  call   map

  xor    a
  ldh    ($42),a                ;Scroll Y
  ldh    ($43),a                ;Scroll X

  ld     a,%11100100            ;BG palette
  ldh    ($47),a
  ldh    ($48),a                ;SPR0 palette

  ld     a,%10010001            ;Turn on screen, BG on, sprites OFF, window OFF, tiles at $8000
  ldh    ($40),a

  ld     a,%00011000            ;Vblank + RLI
  ldh    ($41),a
  ld     a,%00000011
  ldh    ($FF),a

  ld     a,96<<1
  ld     (STRETCH),a
  xor    a
  ld     (FADEIDX),a
  ld     (CURMENU),a

  call   startsfx		;For the menu selection beeps

  ld     hl,VBL_HANDLER
  ld     de,VBL_title
  ld     (hl),e
  inc    hl
  ld     (hl),d

  ld     de,RLI_title
  call   load_RLI

  xor    a
  ld     (VBLC),a
  ldh    ($0F),a                ;Tell pending interrupts we don't give a shit about them
  ei
  ret


VBL_menu:
  ld     a,(CURMENU)		;Display cursor
  ld     de,32			;One tile line
  ld     hl,$9800+(13*32)+3
  or     a
  jr     nz,+
  ld     (hl),'>'-32		;Cursor
  jr     ++
+:
  ld     (hl),0			;Erase
++:
  add    hl,de
  dec    a
  jr     nz,+
  ld     (hl),'>'-32		;Cursor
  jr     ++
+:
  ld     (hl),0			;Erase
++:
  add    hl,de
  dec    a
  jr     nz,+
  ld     (hl),'>'-32		;Cursor
  jr     ++
+:
  ld     (hl),0			;Erase
++:

  call   readinput
  
  ;Konami code handling
  ld     a,(BMODE)
  or     a
  jr     nz,++           	;Ignore if already in bastard mode
  ld     a,(KCODE_BUF+19)
  ld     hl,JOYP_ACTIVE
  cp     (hl)
  jr     z,+
  ld     hl,KCODE_BUF+1		;Shift register to left
  ld     b,19
-:
  ldd    a,(hl)
  ldi    (hl),a
  inc    hl
  dec    b
  jr     nz,-
  ld     a,(JOYP_ACTIVE)
  ld     (KCODE_BUF+19),a       ;New value in end of shift reg
  ld     hl,KCODE_BUF		;Compare with kcode table
  ld     de,kcode_cmp
  ld     b,20
-:
  ld     a,(de)
  ld     b,a
  ldi    a,(hl)
  inc    de
  cp     b
  jr     nz,+
  dec    b
  jr     nz,-
  ld     de,Setup_bmode
  jp     Setup_exit_white
+:
++:

  ld     a,(JOYP_ACTIVE)
  bit    2,a            	;Select
  jr     nz,+           	;or
  bit    7,a            	;Down
  jr     z,++
+:
  ld     hl,fxscore		;Select beep
  call   playsfx
  ;Dplace le curseur
  ld     a,(CURMENU)
  inc    a
  cp     3
  jr     nz,+
  xor    a			;Wrap
+:
  ld     (CURMENU),a
++:

  ld     a,(JOYP_ACTIVE)
  bit    6,a            	;Up
  jr     z,++
  ld     hl,fxscore		;Select beep
  call   playsfx
  ld     a,(CURMENU)
  dec    a
  cp     -1
  jr     nz,+
  ld     a,2			;Wrap
+:
  ld     (CURMENU),a
++:

  ld     a,(JOYP_ACTIVE)
  bit    0,a            	;A
  ret    z
  ld     a,(FRAME)		;Seed PRNG from the frame counter
  ld     (RAND8),a
  ld     hl,jump_menu		;Jump table to launch the menu's selection
  ld     a,(CURMENU)
  ld     d,0
  sla    a
  ld     e,a
  add    hl,de
  ldi    a,(hl)
  ld     d,(hl)
  ld     e,a
  call   Setup_exit_white
  ret

jump_menu:
.dw Setup_world,Setup_passwd,Setup_credits

VBL_title:
  ld     a,(STRETCH)
  dec    a
  dec    a
  or     a
  jr     nz,+
  ;Logo stretch animation done, init menu
  ld     a,%00010000            ;VBL only
  ldh    ($41),a
  ld     a,%00000001            ;VBL only
  ldh    ($FF),a
  ld     de,menu1		;Map menu's text
  ld     hl,$9800+(13*32)+4
  ld     b,32
  call   maptext
  ld     de,menu2
  ld     hl,$9800+(14*32)+4
  call   maptext
  ld     de,menu3
  ld     hl,$9800+(15*32)+4
  call   maptext
  ld     a,TI_T_FOOTER		;Map "FSE" footer
  ld     de,$9800+(17*32)
  ld     hl,(:map_footer*$4000)+map_footer
  call   map
  ;Setup new VBL handler
  ld     hl,VBL_HANDLER
  ld     de,VBL_menu
  ld     (hl),e
  inc    hl
  ld     (hl),d
  xor    a
+:
  ld     (BKG_Y),a
  ld     (STRETCH),a
  ret

RLI_title:
  push   bc
  push   af
  ld     a,(STRETCH)
  ld     b,a
  ldh    a,($44)		;Line number
  cp     b
  jr     nc,+
  ld     a,(BKG_Y)
  srl    a
  ldh    ($42),a                ;Scroll Y
+:
  ld     a,(BKG_Y)
  dec    a
  ld     (BKG_Y),a
  pop    af
  pop    bc
  reti
  
kcode_cmp:
.db $00,$40,$00,$40
.db $00,$80,$00,$80
.db $00,$20,$00,$10
.db $00,$20,$00,$10
.db $00,$02,$00,$01
